void Lock_Camera_Within_Bounds()
{
    //Horizontal
    if(camera.lft < camera_max.lft)
    {
        bg_scroll_pos_x -= camera_max.lft - camera.lft;
        camera.lft = camera_max.lft;
        camera.rgt = camera.lft + 256;
    }
    if(camera.rgt > camera_max.rgt)
    {
        bg_scroll_pos_x -= camera_max.rgt - camera.rgt;
        camera.rgt = camera_max.rgt;
        camera.lft = camera.rgt - 256;;
    }

    //Vertical
    if(camera.top < camera_max.top)
    {
        bg_scroll_pos_y -= camera_max.top - camera.top;
        camera.top = camera_max.top;
        camera.bot = camera.top + 256;
    }
    if(camera.bot > camera_max.bot)
    {
        bg_scroll_pos_y -= camera_max.bot - camera.bot;
        camera.bot = camera_max.bot;
        camera.top = camera.bot - 256;
    }
    if(Room->xsize == 16) bg_scroll_pos_x = 0;
    if(Room->ysize == 16) bg_scroll_pos_y = 0;
}

void Scroll_Camera()
{
    int p = 0;
    camera_scroll.lft = 0;
    camera_scroll.rgt = 0;
    camera_scroll.top = 0;
    camera_scroll.bot = 0;
    if(samvar.dim.rgt > camera.rgt - 108) //Right
    {
        camera_scroll.rgt = samvar.dim.rgt - (camera.rgt - 108);
    }
    if(samvar.dim.lft < camera.lft + 108) //Left
    {
        camera_scroll.lft = camera.lft + 108 - samvar.dim.lft;
    }
    if(samvar.dim.bot > camera.bot - 64) //Down
    {
        camera_scroll.bot = samvar.dim.bot - (camera.bot - 64);
    }
    if(samvar.dim.top < camera.top + 64) //Up
    {
        camera_scroll.top = camera.top + 64 - samvar.dim.top;
    }
    camera_save.lft = 0;
    camera_save.top = 0;
    camera_save.rgt = 0;
    camera_save.bot = 0;
    bg_start_save_x = bg_start_x;
    bg_start_save_y = bg_start_y;
    bg_pos_save_x = bg_scroll_pos_x;
    bg_pos_save_y = bg_scroll_pos_y;
    Update_Cambounds();

    //Scrolls the Camera by using camera_scroll
    if(camera_scroll.lft > camera_scroll.rgt) camera_scroll.rgt = 0;
    else if(camera_scroll.rgt > camera_scroll.lft) camera_scroll.lft = 0;
    if(camera_scroll.top > camera_scroll.bot) camera_scroll.top -= camera_scroll.bot;
    else if(camera_scroll.bot > camera_scroll.top) camera_scroll.bot -= camera_scroll.top;

    if(camera_scroll.lft)
    {
        if(camera_scroll.lft >= 4)
        {
            camera.lft -= 4;
            camera.rgt -= 4;
            bg_scroll_pos_x += 4;
        }
        else
        {
            camera.lft -= camera_scroll.lft;
            camera.rgt -= camera_scroll.lft;
            bg_scroll_pos_x += camera_scroll.lft;
        }
    }
    if(camera_scroll.rgt)
    {
        if(camera_scroll.rgt >= 4)
        {
            camera.lft += 4;
            camera.rgt += 4;
            bg_scroll_pos_x -= 4;
        }
        else
        {
            camera.lft += camera_scroll.rgt;
            camera.rgt += camera_scroll.rgt;
            bg_scroll_pos_x -= camera_scroll.rgt;

        }
    }
    if(camera_scroll.top)
    {
        if(camera_scroll.top >= 4)
        {
            camera.top -= 4;
            camera.bot -= 4;
            bg_scroll_pos_y += 4;

        }
        else
        {
            camera.top -= camera_scroll.top;
            camera.bot -= camera_scroll.top;
            bg_scroll_pos_y += camera_scroll.top;
        }
    }
    if(camera_scroll.bot)
    {
        if(camera_scroll.bot >= 4)
        {
            camera.top += 4;
            camera.bot += 4;
            bg_scroll_pos_y -= 4;
        }
        else
        {
            camera.top += camera_scroll.bot;
            camera.bot += camera_scroll.bot;
            bg_scroll_pos_y -= camera_scroll.bot;
        }
    }
    if(Room->xsize == 16) bg_scroll_pos_x = 0;
    if(Room->ysize == 16) bg_scroll_pos_y = 0;

    if(using_background)
    {
        while(bg_scroll_pos_x > bg_scroll_factor_x)
        {
            bg_start_x ++;
            bg_scroll_pos_x = 0;
        }
        while(bg_scroll_pos_x < 0)
        {
            bg_start_x --;
            bg_scroll_pos_x = bg_scroll_factor_x;
        }
        while(bg_scroll_pos_y > bg_scroll_factor_y)
        {
            bg_start_y ++;
            bg_scroll_pos_y = 0;
        }
        while(bg_scroll_pos_y < 0)
        {
            bg_start_y --;
            bg_scroll_pos_y = bg_scroll_factor_y;
        }
        if(bg_start_x > Background->w) bg_start_x = 0;
        if(bg_start_x < -Background->w) bg_start_x = 0;
        if(bg_start_y > Background->h) bg_start_y = 0;
        if(bg_start_y < -Background->h) bg_start_y = 0;
    }
    Update_Hardened_Cambounds();
}
