void Game_Over_Processes()
{
    music_fade_out_timer -= 8;
    BASS_ChannelSetAttribute(*Cur_Music, BASS_ATTRIB_VOL, (float)(music_fade_out_timer/100.0));
    if(music_fade_out_timer < 1)
    {
        music_fade_out_timer = 0;
        BASS_ChannelStop(*Cur_Music);
    }

    if(game_over_fade_pause > 0)
    {
        game_over_fade_pause --;
        game_over_fade -= 2;
    }
    else
    {
        if(game_over_fade > 0) game_over_fade -= 8;
        if(game_over_fade < 0) game_over_fade = 0;
        if(sam_screen_x < 120) sam_screen_x ++;
        if(sam_screen_x > 120) sam_screen_x --;
        if(sam_screen_y < 112) sam_screen_y ++;
        if(sam_screen_y > 112) sam_screen_y --;
        if(sam_screen_x == 120 AND sam_screen_y == 112 AND game_over_fade == 0) show_game_over_text = true;
        else show_game_over_text = false;

        if(key[KEY_ENTER] AND show_game_over_text)
        {
            game_over_mode = false;
            intro_running = true;
            init_intro = true;
            intro_stage = 0;
            intro_counter = 0;
            star_counter = 0;

            intro_cursor = 0;
            intro_press = 0;
            Destroy_All();
            destroy_bitmap(game_over_fade_image);
            destroy_bitmap(game_over_black_buf);
			//Init back player
			Initialize_Samus();
        }
    }
}

void Game_Over_Draw(BITMAP *output)
{
    clear_to_color(output, 0);
    textprintf_ex(output, font, 0, 0, makecol(0, 255, 0), -1, "%i %i %i", sam_screen_x, sam_screen_y, game_over_fade);
    if(game_over_fade_image)
    {
        draw_sprite(output, game_over_fade_image, 0, 0);
        set_trans_blender(0, 0, 0, 255 - game_over_fade);
        draw_trans_sprite(output, game_over_black_buf, 0, 0);
    }
    draw_sprite_palette(output, Sam_Images[0], sam_screen_x, sam_screen_y, samvar.palette);
    if(show_game_over_text)
    {
         textprintf_ex(output, font, 16, 148, makecol(255, 255, 255), -1, "You let Samus' health hit 0.");
         textprintf_ex(output, font,  4, 156, makecol(255, 255, 255), -1, "What, do you have a death wish?");
         textprintf_ex(output, font, 72, 164, makecol(255, 255, 255), -1, "Press Enter...");
         textprintf_ex(output, font,  4, 172, makecol(255, 255, 255), -1, "Before she gets ugly with you.");
    }
}
