void Intro_Processes()
{
    if(star_counter == 0) Update_Stars();
    star_counter ++;
    if(star_counter == 3) star_counter = 0;

    if(intro_press > 0) intro_press --;
    if(intro_show_message_timer > 0) intro_show_message_timer --;

    if(init_intro)
    {
        Cur_Music = NULL;
        escape_active = false;
        escape_audio = false;
        Cut_All_Audio_Switches();
        Audio.Intro_Music = BASS_StreamCreateFile(FALSE, SOUND"Intro Theme.ogg", 0, 0, BASS_SAMPLE_LOOP);
        BASS_ChannelPlay(Audio.Intro_Music, true);
        BASS_ChannelSetPosition(Audio.Intro_Music, 2705000, BASS_POS_BYTE);

        intro_baseline = (BITMAP *)Image_Datafile[3].dat;
        intro_black = create_bitmap(256, 256);
        intro_backup = create_bitmap(256, 256);
        intro_metroid = (BITMAP *)Image_Datafile[4].dat;
        intro_metroid_mask = Create_Mask(intro_metroid);
        clear_to_color(intro_black, 0);
        intro_counter = 252;
        init_intro = false;
        for(int p = 0; p < 300; p ++)
        {
            Update_Stars();
        }
        if(Get_Cvar_Value_I("skipintro") == 1 AND first_time_intro)
        {
            intro_running = false;
        }
        use_Samstart_this_push = true;
        intro_press = 0;
    }
    else if(intro_stage == 0)
    {
        intro_counter -= 252;
        if(intro_counter <= 0)
        {
            intro_counter = 252;
            intro_stage = 1;
        }
    }
    else if(intro_stage == 1)
    {
        intro_counter -= 4;
        if(intro_counter <= 0)
        {
            intro_counter = 252;
            intro_stage = 2;
        }
    }
    else if(intro_stage == 2)
    {
        intro_counter -= 8;
        if(intro_counter <= 0)
        {
            intro_stage = 3;
        }
    }
    else if(intro_stage == 3) //Menu
    {
        //intro_counter --;
        random_game = false;
        if(samvar.press_up AND !intro_press)
        {
            if(intro_cursor > 0) intro_cursor --;
            intro_press = 15;
        }
        if(samvar.press_down AND !intro_press)
        {
            if(intro_cursor < 2) intro_cursor ++;
            intro_press = 15;
        }
        if(key[KEY_ENTER] AND !intro_press)
        {
            if(intro_cursor == 0) //New Game menu
            {
                intro_stage = 40;
                intro_counter = 80;
                intro_cursor = 0;
                intro_show_message_timer = 0;
            }
            if(intro_cursor == 1) //Random Game
            {
                intro_show_message_timer = 200;
            }
            else if(intro_cursor == 2) //Load Game Menu
            {
                intro_stage = 5;
                intro_counter = 0;
                intro_cursor = 0;//Scrap any existing file data
                intro_show_message_timer = 0;
                if(intro_file_names)
                {
                    for(int i = 0; i < intro_files_found; i ++)
                    {
                        if(intro_file_names[i]) free(intro_file_names[i]);
                        intro_file_names[i] = NULL;
                    }
                    if(intro_file_names) free(intro_file_names);
                    intro_file_names = NULL;
                    intro_files_found = 0;
                }
                printf("Path data scrapped\n");

                //Search for all .bmp files in the folder
                int found = 1;
                al_ffblk TempFileBlock;
                found = al_findfirst(SAVES"*.ssf", &TempFileBlock, FA_ARCH);
                while(found == 0)
                {
                    //Copy the file's name into the paths array
                    intro_file_names = (char **)realloc(intro_file_names, sizeof(char *) * (intro_files_found+1));
                    intro_file_names[intro_files_found] = (char *)malloc(sizeof(char) * (strlen(TempFileBlock.name)+1));
                    Init_String(intro_file_names[intro_files_found], TempFileBlock.name, 0);
                    intro_files_found ++;
                    printf("Found: %s %i\n", TempFileBlock.name, intro_files_found);

                    found = al_findnext(&TempFileBlock);
                }
                al_findclose(&TempFileBlock);
            }
            intro_press = 20;
        }
    }
    else if(intro_stage == 40)
    {
        intro_counter -= 2;
        if(intro_counter <= 0)
        {
            intro_stage = 4;
        }
    }
    else if(intro_stage == 41)
    {
        intro_counter += 2;
        if(intro_counter >= 80)
        {
            intro_counter = 80;
            intro_stage = 3;
        }
    }
    else if(intro_stage == 4) //New Game or Random Game
    {
        if(samvar.press_up AND !intro_press)
        {
            if(intro_cursor > 0) intro_cursor --;
            intro_press = 15;
        }
        if(samvar.press_down AND !intro_press)
        {
            if(intro_cursor < 4) intro_cursor ++;
            intro_press = 15;
        }
        if(key[KEY_ENTER] AND !intro_press)
        {
            if(intro_cursor == 4)
            {
                intro_stage = 41;
                intro_counter = 0;
                intro_cursor = 0;
            }
            else
            {
                intro_stage = 7;
                strclr(intro_new_game_name, 80);
                edit_loc = 0;
            }
            intro_press = 15;
        }

        if(intro_cursor == 0)
        {
            intro_en_speed = 1;
            intro_en_health = 1;
        }
        else if(intro_cursor == 1)
        {
            intro_en_speed = 1;
            intro_en_health = 2;
        }
        else if(intro_cursor == 2)
        {
            intro_en_speed = 2;
            intro_en_health = 3;
        }
        else if(intro_cursor == 3)
        {
            intro_en_speed = 4;
            intro_en_health = 4;
        }
    }
    else if(intro_stage == 5) //Savefile
    {
        if(key[KEY_ENTER] AND !intro_press)
        {
            if(intro_cursor == 0)
            {
                intro_stage = 3;
                intro_counter = 0;
                intro_press = 15;
            }
            else
            {
                intro_stage = 6;
                intro_counter = 255;
                clear_to_color(intro_backup, 0);
                draw_sprite(intro_backup, buffer, 0, 0);
                printf("Loading savefile... ");
                char *newsave = (char *)malloc(sizeof(char) * (strlen(intro_file_names[intro_cursor-1]) + 7));
                Init_String(newsave, SAVES, strlen(intro_file_names[intro_cursor-1]) + 7);
                strcat(newsave, intro_file_names[intro_cursor-1]);
                printf("%s\n", newsave);
                Init_String(Saveout_path, newsave, 80);
                Load_Save_File(Saveout, newsave);
                if(newsave) free(newsave);
                newsave = NULL;
                printf("Done\n");
                //Room = NULL;
                printf("Loading room from %s\n", Saveout->roomname);
                char *newlev = (char *)malloc(sizeof(char) * (6 + Saveout->roomname_len + 1));
                Init_String(newlev, ROOMS, 7);
                strcat(newlev, Saveout->roomname);
                Read_Level(newlev, &Room);
                cnt = -1;
                if(newlev) free(newlev);
                newlev = NULL;
                if(Room == NULL)
                {
                    printf("Creating averting level...");
                    Create_Simple_Level();
                    curlev = -1;
                    printf(" Done\n");
                }
            }
        }
        if(samvar.press_up AND !intro_press)
        {
            if(intro_cursor > 1) intro_cursor --;
            intro_press = 15;
        }
        if(samvar.press_down AND !intro_press)
        {
            if(intro_cursor < intro_files_found) intro_cursor ++;
            intro_press = 15;
        }
        if(samvar.press_left AND intro_cursor > 0 AND !intro_press) //Switch to the EXIT button
        {
            intro_cursor = 0;
            intro_press = 15;
        }
        if(samvar.press_right AND intro_cursor == 0 AND !intro_press AND intro_files_found > 0) //Switch to file selection
        {
            intro_cursor = 1;
            intro_press = 15;
        }
    }
    else if(intro_stage == 6)
    {
        intro_counter -= 8;
        if(intro_counter <= 0)
        {
            intro_counter = 0;
            intro_running = false;
        }
    }
    else if(intro_stage == 7)
    {
        for(int i = 0; i < total_keys; i ++)
        {
            if(i == 62 OR i == 66)
            {
                ;
            }
            else if(*Keylist[i].key AND Keylist[i].repress == false)
            {
                if(key[KEY_LSHIFT] OR key[KEY_RSHIFT])
                    intro_new_game_name[edit_loc] = Keylist[i].shkey;
                else
                    intro_new_game_name[edit_loc] = Keylist[i].askey;
                Keylist[i].repress = true;
                edit_loc ++;
                if(edit_loc >= 12) edit_loc = 12;
                intro_new_game_name[12] = 0;
                break;
            }
        }
        if(key[KEY_BACKSPACE] AND !Keylist[62].repress)
        {
            Keylist[62].repress = true;
            intro_new_game_name[edit_loc-1] = 0;
            edit_loc --;
            if(edit_loc < 0) edit_loc = 0;
        }
        if(key[KEY_ENTER] AND !intro_press)
        {
            Init_String(Saveout_path, SAVES, 80);
            strcat(Saveout_path, intro_new_game_name);
            strcat(Saveout_path, ".ssf");
            intro_stage = 6;
            intro_counter = 255;
            clear_to_color(intro_backup, 0);
            draw_sprite(intro_backup, buffer, 0, 0);
            if(random_game)
            {
                Room = NULL;
                Create_Random_Level(false, false, rnd(5, 10), 0);
            }
            else
            {
                char *startlevval = Get_Cvar_Value_C("st");
                Room = NULL;
                Read_Level(Get_Cvar_Value_C("st"), &Room);
                cnt = -1;
                if(Room == NULL)
                {
                    printf("Creating averting level...");
                    Create_Simple_Level();
                    curlev = -1;
                    printf(" Done\n");
                }
            }
            //Init_String(edit_string, newstring, 0);
        }
    }

    //Override key
    if(intro_running == false)
    {
        BASS_ChannelStop(Audio.Intro_Music);
        game_paused = false;
        //destroy_bitmap(intro_baseline);
        //destroy_bitmap(intro_black);
        //destroy_bitmap(intro_metroid);
        //destroy_bitmap(intro_metroid_mask);
        if(Room == NULL)
        {
            Read_Level(Get_Cvar_Value_C("st"), &Room);
            cnt = -1;
            if(Room == NULL)
            {
                printf("Creating averting level...");
                Create_Simple_Level();
                curlev = -1;
                printf(" Done\n");
            }
        }
        if(!Samstart.active)
        {
            samvar.x = 64;
            samvar.y = 64;
        }
        first_time_intro = false;
    }
    subscreen_cooldown = 120;
    if(!intro_running)
    {
        printf("Exiting intro\n");
    }
}

void Draw_Intro(BITMAP *output)
{
    clear_to_color(output, 0);
    for(int i = 0; i < total_stars; i ++)
    {
        if(Stars[i].active) putpixel(output, Stars[i].x, Stars[i].y, Stars[i].color);
    }
    if(intro_stage == 0) //Developer's stuff
    {
    }
    else if(intro_stage == 1) //Background fades in
    {
        set_trans_blender(0, 0, 0, intro_counter);
        draw_sprite(output, intro_baseline, 0, 0);
        draw_trans_sprite(output, intro_black, 0, 0);
    }
    else if(intro_stage == 2) //METROID Fade in
    {
        set_trans_blender(0, 0, 0, intro_counter);
        draw_sprite(output, intro_baseline,  0,  0);
        draw_sprite(output, intro_metroid , 25, 48);
        draw_trans_sprite(output, intro_metroid_mask, 25, 48);
    }
    else if(intro_stage == 3) //Menu
    {
        draw_sprite(output, intro_baseline,  0,  0);
        draw_sprite(output, intro_metroid , 25, 48);
        Draw_Box(output, 101, 115, 173, 160);
        textprintf_ex(output, font, 117, 124, makecol(168, 228, 252), -1, "New");
        textprintf_ex(output, font, 117, 135, makecol(168, 228, 252), -1, "Random");
        textprintf_ex(output, font, 117, 146, makecol(168, 228, 252), -1, "Load");
        draw_sprite(output, arrow, 105, 124 + intro_cursor * 11);
        if(intro_show_message_timer > 0)
        {
            textprintf_ex(output, font, 60, 170, makecol(168, 228, 252), -1, "Not supported yet");
        }
    }
    else if(intro_stage == 40 OR intro_stage == 41)
    {
        draw_sprite(output, intro_baseline,  0,  0);
        int x1pos = 16  + ((float)intro_counter * 1.0625);
        int y1pos = 16  + ((float)intro_counter * 1.2375);
        int x2pos = 150 + ((float)intro_counter * 0.2875);
        int y2pos = 91  + ((float)intro_counter * 0.8625);
        Draw_Box(output, x1pos, y1pos, x2pos, y2pos);
    }
    else if(intro_stage == 4) //New Game Menu
    {
        draw_sprite(output, intro_baseline,  0,  0);
        Draw_Box(output, 16, 16, 150, 91);
        textprintf_ex(output, font,  32,  25, makecol( 66,  66, 255), -1, "New Game");
        textprintf_ex(output, font,  32,  38, makecol(168, 228, 252), -1, "Normal");
        textprintf_ex(output, font,  32,  47, makecol(168, 228, 252), -1, "Hard");
        textprintf_ex(output, font,  32,  56, makecol(168, 228, 252), -1, "Impossible");
        textprintf_ex(output, font,  32,  65, makecol(168, 228, 252), -1, "Gentlemen?");
        textprintf_ex(output, font,  32,  74, makecol(168, 228, 252), -1, "Back");
        draw_sprite(output, arrow, 20, 38 + intro_cursor * 9);

        if(intro_cursor < 4)
        {
            Draw_Box(output,  16, 100, 165, 136);
            textprintf_ex(output, font,  32, 109, makecol( 66,  66, 255), -1, "Enemy Speed  %ix", intro_en_speed);
            textprintf_ex(output, font,  32, 118, makecol( 66,  66, 255), -1, "Enemy Health %ix", intro_en_health);
        }
    }
    else if(intro_stage == 5) //Load Game Menu
    {
        draw_sprite(output, intro_baseline,  0,  0);
        Draw_Box(output, 16, 16, 80, 42);
        textprintf_ex(output, font,  32,  25, makecol(168, 228, 252), -1, "Back");
        Draw_Box(output, 88, 16, 248, 136);
        textprintf_ex(output, font,  104,  25, makecol(168, 228, 252), -1, "Saves");
        for(int i = 0; i < intro_files_found; i ++)
        {
            textprintf_ex(output, font, 104, 38 + i * 9, makecol(168, 228, 252), -1, "%s", intro_file_names[i]);
        }
        if(intro_cursor == 0)
        {
            draw_sprite(output, arrow, 20, 25);
        }
        else
        {
            draw_sprite(output, arrow, 92, 38+(intro_cursor-1)*9);
        }
    }
    else if(intro_stage == 6) //Fading out
    {
        draw_sprite(output, intro_backup, 0, 0);
        set_trans_blender(0, 0, 0, 255-intro_counter);
        draw_trans_sprite(output, intro_black, 0, 0);
    }
    else if(intro_stage == 7) //Enter a name
    {
        draw_sprite(output, intro_baseline,  0,  0);
        Draw_Box(output, 72, 104, 176, 120);
        textprintf_ex(output, font, 77, 109, makecol(168, 228, 252), -1, "Enter a name");
        Draw_Box(output, 72, 124, 176, 140);
        textprintf_ex(output, font, 77, 129, makecol(168, 228, 252), -1, "%s", intro_new_game_name);
    }
}

void Draw_Box(BITMAP *output, int x1, int y1, int x2, int y2)
{
    draw_sprite        (output, box_corner, x1, y1);
    draw_sprite_h_flip (output, box_corner, x2-4, y1);
    draw_sprite_v_flip (output, box_corner, x1, y2-4);
    draw_sprite_vh_flip(output, box_corner, x2-4, y2-4);

    //Horizontal
    line(output, x1+4, y1  , x2-4, y1  , boxcol_one);
    line(output, x1+4, y1+1, x2-4, y1+1, boxcol_two);
    line(output, x1+4, y1+2, x2-4, y1+2, boxcol_one);

    line(output, x1+4, y2-2, x2-4, y2-2, boxcol_one);
    line(output, x1+4, y2-1, x2-4, y2-1, boxcol_two);
    line(output, x1+4, y2  , x2-4, y2  , boxcol_one);

    //Vertical
    line(output, x1  , y1+4, x1  , y2-4, boxcol_one);
    line(output, x1+1, y1+4, x1+1, y2-4, boxcol_two);
    line(output, x1+2, y1+4, x1+2, y2-4, boxcol_one);

    line(output, x2-2, y1+4, x2-2, y2-4, boxcol_one);
    line(output, x2-1, y1+4, x2-1, y2-4, boxcol_two);
    line(output, x2  , y1+4, x2  , y2-4, boxcol_one);
}

