void Credits_Processes()
{
    samvar.lockout_controls = false;
    if(star_counter == 0) Update_Stars();
    star_counter ++;
    if(star_counter >= 3) star_counter = 0;

    skip_drawing_credits_this_pulse = false;

    if(key[KEY_A])
    {
        intro_running = true;
        init_intro = true;
        intro_stage = 0;
        intro_counter = 0;
        star_counter = 0;

        intro_cursor = 0;
        intro_press = 0;
        Destroy_All();
        credits_running = false;
    }

    if(init_credits)
    {
        Destroy_All();
        printf("Credits initting\n");
        Cut_All_Audio_Switches();
        Audio.Ending_Music = BASS_StreamCreateFile(FALSE, SOUND"Ending Music.ogg", 0, 0, 0);
        BASS_ChannelPlay(Audio.Ending_Music, true);
        credits_stage = 0;
        credits_timer = 0;
        init_credits = false;
        credits_back = (BITMAP *)Image_Datafile[3].dat;

        for(int p = 0; p < 300; p ++)
        {
            Update_Stars();
        }
        printf("Credits initted\n");
    }

    if(credits_stage == 0) //Show the text, and Samus in armor
    {
        credits_timer ++;
        if(credits_timer > 1150)
        {
            credits_timer = 0;
            credits_stage = 5;
            skip_drawing_credits_this_pulse = true;
        }
    }
    else if(credits_stage == 1) //Samus flashing
    {
    }
    else if(credits_stage == 2) //Samus without suit
    {
    }
    else if(credits_stage == 3) //Samus waves
    {
    }
    else if(credits_stage == 4) //Fade out
    {
    }
    else if(credits_stage == 5) //Rolling credits
    {
        if(credits_timer == 0)
        {
            credits_text = create_bitmap(256, 1000);
            clear_to_color(credits_text, 0);
            textprintf_ex(credits_text, font, 36,   0, white, -1, "Metroid Classic Credits");

            textprintf_ex(credits_text, font, 48,  24, white, -1, "Idea and Programming");
            textprintf_ex(credits_text, font, 76,  32, white, -1, "Salty Justice");

            textprintf_ex(credits_text, font, 36,  48, white, -1, "Sweat, Tears, and Blood");
            textprintf_ex(credits_text, font, 76,  56, white, -1, "Salty Justice");

            textprintf_ex(credits_text, font, 68,  72, white, -1, "Editor, Support");
            textprintf_ex(credits_text, font, 72,  80, white, -1, "Toasty Justice");

            textprintf_ex(credits_text, font, 36, 104, white, -1, "Bug Testing, Hangers-on");
            textprintf_ex(credits_text, font, 68, 112, white, -1, "Sudtrap, Nureru");
            textprintf_ex(credits_text, font, 32, 120, white, -1, "Other people on the blog");
            textprintf_ex(credits_text, font, 72, 128, white, -1, "(You guys SUCK)");

            textprintf_ex(credits_text, font, 48, 152, white, -1, "Support, Misc Duties");
            textprintf_ex(credits_text, font, 104,160, white, -1, "Danika");

            textprintf_ex(credits_text, font, 28, 176, white, -1, "In Memory of Gunpei Yokoi");

            textprintf_ex(credits_text, font, 66, 192, white, -1, "Special Thanks To:");
            textprintf_ex(credits_text, font, 62, 200, white, -1, "New Age Retro Gamer");

            textprintf_ex(credits_text, font, 112, 216, white, -1, "Cast");
            BITMAP *cast_bmp = (BITMAP *)Image_Datafile[0].dat;
            draw_sprite(credits_text, cast_bmp, 0, 216);
            destroy_bitmap(cast_bmp);
        }
        credits_timer ++;
        if(credits_timer >= 8000)
        {
            intro_running = true;
            init_intro = true;
            intro_stage = 0;
            intro_counter = 0;
            star_counter = 0;

            intro_cursor = 0;
            intro_press = 0;
            Destroy_All();
            credits_running = false;
        }
    }
}

void Draw_Credits(BITMAP *output)
{
    clear_to_color(output, 0);
    //textprintf_ex(output, font, 0, 0, white, -1, "Credits drawing");
    //textprintf_ex(output, font, 0, 8, white, -1, "%i %i", credits_stage, credits_timer);
    if(credits_stage == 0) //Show the text, and Samus in armor
    {
        for(int i = 0; i < total_stars; i ++)
        {
            if(Stars[i].active) putpixel(output, Stars[i].x, Stars[i].y, Stars[i].color);
        }
        draw_sprite(output, credits_back, 0, 0);
        textprintf_ex(output, font, 64,  16, white, -1, "Congratulations!");
        textprintf_ex(output, font,  0,  24, white, -1, "You have completed your mission,");
        textprintf_ex(output, font, 32,  32, white, -1, "and destroyed the Mother");
        textprintf_ex(output, font, 12,  40, white, -1, "Brain.  The Space Pirates are");
        textprintf_ex(output, font,  0,  48, white, -1, "withdrawing, and a blow has been");
        textprintf_ex(output, font,  8,  56, white, -1, "dealt agains evil that will be");
        textprintf_ex(output, font, 44,  64, white, -1, "felt for generations.");

        textprintf_ex(output, font,  8,  80, white, -1, "Peace will at last flourish in");
        textprintf_ex(output, font,  0,  88, white, -1, "space, but your work is far from");
        textprintf_ex(output, font,  4,  96, white, -1, "over.  There are other Metroids");
        textprintf_ex(output, font, 12, 104, white, -1, "in the cosmos, and dark minds");
        textprintf_ex(output, font, 36, 112, white, -1, "may harness them again.");
    }
    else if(credits_stage == 1) //Samus flashing
    {
    }
    else if(credits_stage == 2) //Samus without suit
    {
    }
    else if(credits_stage == 3) //Samus waves
    {
    }
    else if(credits_stage == 4) //Fade out
    {
    }
    else if(credits_stage == 5) //Rolling credits
    {
        draw_sprite(output, credits_text, 0, 256 - (float)(credits_timer / 8.0));
        if(credits_timer > 7000)
        {
            textprintf_ex(output, font, 44, 124, white, -1, "See you next mission.");
        }
    }
}
