//MTC.h
void increment_speed_counter();

////////////////////////////////////////////////////////////////////////////////
// Enemies sub folder
//
//// 0Enemies.h
void Initialize_Enemies();
void Update_Enemies();
void Immunize_From_Beam(int, int);
//// 1Enemy_Structures.h
//
//// 2Enemy_Redirects.h
//
//// 3Enemy_Collision.h
void Compare_Enemy_Collision();
void Injure_Samus(int);
//// Enemy_Spawner.h
void Create_Enemy_Spawner(int, int, bool, int, int, bool, int);
void Place_Enemy_Spawner_In_Slot(int, int, int, bool, int, int, bool, int);
void Update_Enemy_Spawners();
//// Firehorse.h
int Create_Firehorse(int, int, bool);
void Place_Firehorse_In_Slot(int, int, int, bool);
void Update_Firehorse(int);
//// Geemers.h
int Create_Geemer(int, int, bool, int);
void Place_Geemer_In_Slot(int, int, int, bool, int);
void Update_Geemer(int);
void Update_Geemer_GFX(int);
void Update_Nova_GFX(int);
void Update_Zeela_GFX(int);
void Update_Viola_GFX(int);
void Move_Enemy(int, int, int);
void Move_Enemy_Bounce(int, int, int , unsigned char*, unsigned char*);
//// Gerutas.h
int Create_Geruta(int, int, bool, int);
void Place_Geruta_In_Slot(int, int, int, bool, int);
void Update_Geruta(int);
//// Kraid.h
void Init_Kraid(int, int, bool);
void Destroy_Kraid();
void Immunize_Kraid_From_Beam(int);
void Damage_Kraid(int);
void Draw_Kraid(BITMAP*);
void Tear_Kraid_Into_Giblets(int, int);
void Create_Kraid_Gib(CUSTOM_IMAGE*, int, int, int, int);
void Update_Kraid();
//// Kraid_Support.h
void Create_Kraid_Needle(int x, int y, int facing);
void Place_Needle_In_Slot(int i, int x, int y, int facing);
void Update_Kraid_Needles();
void Create_Kraid_Hook(int x, int y, int facing);
void Place_Hook_In_Slot(int i, int x, int y, int facing);
void Draw_Kraid_Support(BITMAP *output);
//// Metroids.h
int Create_Metroid(int x, int y, bool hardtype);
void Place_Metroid_In_Slot(int i, int x, int y, bool hardtype);
void Update_Metroid_GFX(int i);
void Update_Metroid(int i);
//// Minigun.h
void Create_Minigun(int, int, int);
void Place_Minigun_In_Slot(int, int, int, int);
void Set_Lookup_Vals(int, int, int, int, int, int, bool, bool, CUSTOM_IMAGE*, bool);
void Update_Miniguns();
void Draw_Miniguns(BITMAP*);
//// Mother_Brain.h
void Init_Mother_Brain();
void Destroy_Mother_Brain();
void Damage_Mother_Brain(int);
void Update_Mother_Brain();
void Draw_Mother_Brain(BITMAP *);
//// Multiviola
int Create_Multiviola(int, int, bool);
void Place_Multiviola_In_Slot(int, int, int, bool);
void Update_Multiviola(int);
//// Reo.h
int Create_Reo(int, int, bool);
void Place_Reo_In_Slot(int, int, int, bool);
void Update_Reo(int);
//// Ridley.h
void Init_Ridley(int, int);
void Destroy_Ridley();
void Immunize_Ridley_From_Beam(int);
void Update_Ridley();
void Damage_Ridley(int);
void Draw_Ridley(BITMAP*);
void Move_Fireball(int, int, int);
void Create_Ridley_Fireball(int, int, float, float, float, float);
void Tear_Ridley_Into_Giblets(int xstep, int ystep);
void Create_Ridley_Gib(CUSTOM_IMAGE *src, int lft, int top, int rgt, int bot);
bool Check_If_Valid_Giblet(CUSTOM_IMAGE *src, int lft, int top, int rgt, int bot);
//// Rinka.h
int Create_Rinka(int, int, bool, int);
void Place_Rinka_In_Slot(int, int, int);
void Update_Rinka(int);
void Draw_Rinkas(BITMAP*);
//// Rippers.h
int Create_Ripper(int, int, bool, int);
void Place_Ripper_In_Slot(int, int, int, bool, int);
void Update_Ripper(int);
//// Shriekbats.h
int Create_Shriekbat(int, int, bool);
void Place_Shriekbat_In_Slot(int, int, int, bool);
void Update_Shriekbat(int);
//// Sidehopper.h
int Create_Sidehopper(int, int, bool, int);
void Place_Sidehopper_In_Slot(int, int, int, bool, int);
void Update_Sidehopper(int);
//// Squeept.h
int Create_Squeept(int, int, bool);
void Place_Squeept_In_Slot(int, int, int, bool);
void Update_Squeept(int);
//// Waver.h
int Create_Waver(int, int, bool);
void Place_Waver_In_Slot(int, int, int, bool);
void Update_Waver(int);
//// Zeb.h
int Create_Zeb(int, int, bool, int);
void Place_Zeb_In_Slot(int, int, int, bool, int);
void Update_Zeb(int);
////Zebetites.h
void Create_Zebetite(int lft, int top, int rgt, int bot, int health);
void Place_Zebetite_In_Slot(int i, int lft, int top, int rgt, int bot, int health);
void Update_Zebetite(int i);
void Draw_Zebetites(BITMAP *output);

////////////////////////////////////////////////////////////////////////////////
// Credits sub folder
//
//// Credits.h
void Credits_Processes();
void Draw_Credits(BITMAP*);

////////////////////////////////////////////////////////////////////////////////
// Intro sub folder
//
//// Intro.h
void Intro_Processes();
void Draw_Intro(BITMAP*);
void Draw_Box(BITMAP*, int, int, int, int);
//// Stars.h
void Create_Star_Random();
void Update_Stars();

////////////////////////////////////////////////////////////////////////////////
// Scripting sub folder
//
//// Core.h
void Init_Script_Engine(char[]);
SCRIPT *Init_Script(char[]);
void Destroy_Script(SCRIPT*);
void Add_New_Line_To_Script(SCRIPT*, char[], int);
void Dump_Script_To_Console(SCRIPT*);
//// Scp_Variables.h
void Create_Variable_From_Script(LINE);
void Parse_Script_For_Variables(SCRIPT*);
////////////////////////////////////////////////////////////////////////////////

//Audio.h
void Cut_All_Audio_Switches();

//Breakables.h
int  Create_Breakable(int, int, int, int, bool, int);
void Place_Breakable_In_Slot(int, int, int, int, int, bool, int);
void Update_Breakables();
void Compare_Breakables_To_Bombs(int);

//Cambounds.h
void Create_Cambound(int, int, int, int, int);
void Update_Cambounds();
void Update_Hardened_Cambounds();

//Camera.h
void Lock_Camera_Within_Bounds();
void Scroll_Camera();

//Clipping
void Detect_Samus_Collision();
void Update_Samus_Clips();
void Update_Samus_Clips_Return();
void Lock_Samus_Speed(float, float);
void Move_Samus();

//Clips.h
void Create_Clips(int, int, int**);
void Secure_Clips(int, int, int**);
bool Scan_Clips_X(int, int, int, unsigned char);
bool Scan_Clips_Y(int, int, int, unsigned char);
bool Scan_Clips_Rect(int, int, int, int, unsigned char);
bool rect_clip(DIMENSION dim1, int, int, int, int);
bool rect_clip(DIMENSION, DIMENSION);
void Clip_Area(int, int, int, int, int);
void Clip_Area(DIMENSION, int);
void Freeze_Clip_Area(DIMENSION, int);
void Unclip_Area(DIMENSION, int);

//Create.h
void Create_Key(char, char, char, char, int, int);
void Create_Key(char, int, int);
void Create_Control(char, char, int*);
void Assign_Control(char, char);
void Create_CVar_I(char[], int);
void Create_CVar_C(char[], char[]);
BITMAP *Create_Mask(BITMAP*);
CUSTOM_IMAGE *Create_Copy_Of_Custom_Image(CUSTOM_IMAGE*, int, int, int, int);

//Destructors.h
void Destroy_Room();
void Destroy_Cambounds();
void Destroy_Doors();
void Destroy_Breakables();
void Destroy_Elevators();
void Destroy_Enemies();
void Destroy_Miniguns();
void Destroy_Enemy_Spawners();
void Destroy_Projectiles();
void Destroy_Targets();
void Destroy_Sprites();
void Destroy_Sprite_Spawners();
void Destroy_Transitions();
void Destroy_Items();
void Destroy_Water();
void Destroy_Zebetites();
void Destroy_All();

//Doors.h
void Create_Door(char[], int, int, int);
void Create_Transition_Zone(char[], char[], int, int, int, int, int, char[], char[]);
void Update_Doors();
void Refresh_Door_Hooks();
void Open_Door(int);
void Open_Door(DOOR*);
void Neutralize_Opened_Doors();
void Update_Transitions();

//Draw.h
void Draw_Everything(BITMAP*);
void Draw_Background(BITMAP *);
void Draw_Tiles(BITMAP *);
void Draw_Foreground_Tiles(BITMAP*);
void Draw_Background_Tiles(BITMAP*);
void Draw_Elevators(BITMAP*);
void Draw_Items(BITMAP*);
void Draw_Doors(BITMAP*);
void Draw_Water(BITMAP *, int);
void Draw_Projectiles(BITMAP*);
void Draw_Bombs(BITMAP*);
void Draw_Enemies(BITMAP*);
void Draw_Sprites(BITMAP*);
void Draw_HUD(BITMAP*);
void Draw_Breakables(BITMAP*);
void Draw_Savezone(BITMAP*);

//Draw_Sam.h
void Decide_Samus_Frame_Metroid(); //Metroid

//Draw_Utility.h
void draw_sprite_palette(BITMAP *, CUSTOM_IMAGE *, int, int, int);
void draw_sprite_h_flip_palette(BITMAP *, CUSTOM_IMAGE *, int, int, int);
void draw_sprite_v_flip_palette(BITMAP *, CUSTOM_IMAGE *, int, int, int);
void draw_sprite_vh_flip_palette(BITMAP *, CUSTOM_IMAGE *, int, int, int);
void rotate_sprite_palette(BITMAP *, CUSTOM_IMAGE *, int, int, int, fixed);
void Draw_To_Screen(BITMAP*);

//Elevators.h
void Create_Elevator(int, int, char, char[]);
void Update_Elevators();

//Fading.h
void Unfade_Tiles(BITMAP*, int);

//File_Load.h
void Load_Save_File(SAVEFILE *, char[]);

//File_Save.h
void Update_Save_File_Roomname(SAVEFILE *, char[]);
void Update_Save_File_Stats(SAVEFILE *);
void Write_Save_File(SAVEFILE *, char[]);
void Add_Door_To_Opened_List(SAVEFILE *, char[], char[], int);
void Clear_Save_Data(SAVEFILE *);
void Add_Saved_Object(SAVEFILE*, int);
void Create_Save_Zone(int, int, int, int);
void Update_Save_Zone();

//Gameover.h
void Game_Over_Processes();
void Game_Over_Draw(BITMAP*);

//Initialize.h
void Initialize_Everything();
void Create_Keylist();
void Create_Control_List();
void Create_CVar_List();
void Initialize_Campaign(char[]);
void Initialize_Samus();

//Items.h
void Create_Random_Item(DIMENSION, int, bool);
void Create_Item(int, int, int, bool);
int  Create_Item(int, int, int, char[], int);
void Place_Item_In_Slot_No_Fanfare(int, int, int, int, bool);
void Place_Item_In_Slot(int, int, int, int, char[], int);
void Update_Items();
void Update_All_Collected_Switches();
void Update_Saved_Switch(bool*, bool*, int);
void Clear_Collected_Items();

//Keys.h
void Accept_Keys();

//Levels.h
void Create_Simple_Level();
void Read_Level(char[], ROOM **);
void Load_Level_From_Campaign(char name[], ROOM **LoadRoom);
void Apply_Special_Features_To_Level();

//LoadAtStart.h
void Load_ISF_Images();
void Load_Samus_Images_One();
void Load_Samus_Images_Two();
void Load_Enemy_Images();
void Load_Datafile_Images();

//MCI.h
MCI_FILE * Open_MCI_File(char path[]);
//CUSTOM_IMAGE *Create_Image_From_MCI(FILE *input_mci, int *ctr, bool increase);
CUSTOM_IMAGE *Create_Image_From_MCI(MCI_FILE *Mci_File, char name[], int);
void Fill_Data(CUSTOM_IMAGE*, FILE*);
void Fill_Data_h_flip(CUSTOM_IMAGE*, FILE*);
void Fill_Data_v_flip(CUSTOM_IMAGE*, FILE*);
void Fill_Data_vh_flip(CUSTOM_IMAGE*, FILE*);
BITMAP *Create_Bitmap_From_MCI(MCI_FILE *Mci_File, char name[]);
CUSTOM_IMAGE *Create_Blank_Custom_Image(int xsize, int ysize, int palettes, int colors);
void Copy_Custom_Image_Palette_Data(CUSTOM_IMAGE *src, CUSTOM_IMAGE *dest);

//Map.h
void Update_Map_Clearing(MAP *Map, int x, int y, int val);
MAP *Create_Map(char name[], int xsize, int ysize, BITMAP *base);
void Display_Map(BITMAP *output, MAP *Map, int xpos, int ypos, int map_x, int map_y);
void Display_Map(BITMAP *output, MAP *Map, int xpos, int ypos);

//Miscellaneous.h
int rnd(int, int);
char * bitwise_to_string(unsigned char);
void Swap_These(int*, int*);

//Pause.h
void Pause_Processes();

//Processes.h
void Game_Processes();

//Random.h
void Create_Random_Level(bool, bool, int, int);

//Recolors.h
RECOLOR_PACK *Create_Recolor(int, ...);
void Add_Palette(RECOLOR_PACK**, ...);
void Recolor_Blit(BITMAP*, BITMAP*, int, int, int, int, int, int, RECOLOR_PACK*, int);
void Recolor_Bitmap(BITMAP*, BITMAP*, int, int, RECOLOR_PACK*, int);
void Recolor_Bitmap_h_flip (BITMAP*, BITMAP*, int, int, RECOLOR_PACK*, int);
void Recolor_Bitmap_v_flip (BITMAP*, BITMAP*, int, int, RECOLOR_PACK*, int);
void Recolor_Bitmap_vh_flip(BITMAP*, BITMAP*, int, int, RECOLOR_PACK*, int);

//Retrieve.h
int Retrieve_Door(char name[]);
int Retrieve_Transition(char name[]);

//Samstart.h
void Create_Samstart(int, int);
void Update_Samstart();

//Scripts.h
int Read_Config_File(char[]);
CVAR *Find_CVar(char[]);
int Get_Cvar_Value_I(char[]);
char *Get_Cvar_Value_C(char[]);
void Update_CVar(CVAR*, int);
void Update_CVar(CVAR*, char[]);

//Shots.h
void Create_Projectile(int, int);
void Place_Shot_In_Slot(int, int, int);
void Create_Bomb(int, int);
void Place_Bomb_In_Slot(int, int, int);
void Update_Projectiles();
bool Detect_Projectile_Collision_Clips(int);
void Terminate_Projectiles();
void Assemble_Samus_Beam_Data();
void Assemble_Samus_Missile_Data();
void draw_shot_special(BITMAP*, CUSTOM_IMAGE*, int, int, int, DIMENSION);
void draw_shot_special_h_flip(BITMAP*, CUSTOM_IMAGE*, int, int, int, DIMENSION);
void rotate_shot_special(BITMAP*, CUSTOM_IMAGE*, int, int, int, fixed, DIMENSION);
void Create_Helix_Shot_Sprites(int);

//Spawners.h
void Create_Sprite_Spawner(int, int, int, int, int, void (*hookfunc)(int));
void Update_Spawners();

//Sprites.h
int Place_Sprite_In_Slot(int, int, int, int, int, int, int, int);
int Create_Sprite(int, int, int, int, int);
int Create_Sprite(int, int, int);
int Create_Sprite(int, int, int, int, int, int, int);
int Create_Sprite(int, int, int, CUSTOM_IMAGE*);
void Deactive_Sprite(int);

void Imagize_Sprite_Explosion(int);
void Imagize_Sprite_Droplet_One(int);
void Imagize_Sprite_Droplet_Two(int);
void Imagize_Sprite_Splash(int);
void Imagize_Sprite_Explosion_Bit(int, float, float, bool, bool, fixed);
void Imagize_Sprite_Shriekbat_Orb(int, float, float);
void Imagize_Sprite_Firehorse(int, int);
void Imagize_Sprite_Giblet(int, CUSTOM_IMAGE*);
void Imagize_Sprite_Minigun_Shot(int, int);

void Update_Sprites();

//Subscreen.h
void Subscreen_Processes();
void Draw_Subscreen(BITMAP*);
void Create_Subscreen_Item(int, int, int, int, int, bool*, bool*, char[]);
void Set_Item_Path(int, int, int, int, int);
void Make_Exclusive_With(int, int);
void Draw_Subscreen_Item(BITMAP*, int);

//Targets.h
void Add_To_Target_List(int, int);
void Remove_From_Target_List(int*);
void Update_Target_List();
void Compare_Targets_To_Projectiles();
void Compare_Targets_To_Screw_Attack();
void Deal_Damage_To_Target(int, int);
void Compare_Targets_To_Bombs(int);

//Water.h
void Create_Water_Zones(int, int, int, int, int);
int Create_Water_Zone(int, int, int, int, int, bool);
void Place_Water_Zone_In_Slot(int, int, int, int, int, int, bool);
void Update_Water_Zones();
