void Draw_Everything(BITMAP *output)
{
    if(debug_write) printf("S");
    clear_to_color(output, 0);

    //if(Background) Draw_Background(output);

    if(!Samstart.active) Draw_Enemies(output);
    if(debug_write) printf("E");
    Draw_Ridley(output);
    if(debug_write) printf("R");
    Draw_Kraid(output);
    if(debug_write) printf("K");
    Draw_Mother_Brain(output);
    if(debug_write) printf("M");

    //Projectiles
    Draw_Projectiles(output);
    if(debug_write) printf("P");

    //Draw Samus to the screen
    if(samvar.invincible_timer % 4 < 2 AND !do_not_draw_samus)
    {
        if(Sam_Display)
        {
            if(frame_flip)
                draw_sprite_h_flip_palette(output, Sam_Display, samvar.x+sam_offset_x-camera.lft, samvar.y+sam_offset_y-camera.top, samvar.palette);
            else
                draw_sprite_palette(output, Sam_Display, samvar.x+sam_offset_x-camera.lft, samvar.y+sam_offset_y-camera.top, samvar.palette);
        }
        /*if(samvar.ball_mode)
        {
            if(samvar.ball_frame < 0)
            {
                if(samvar.facing == RIGHT) draw_sprite_palette(output, Sam_Images[2], samvar.x + sam_img_offset_x[2] - camera.lft, samvar.y + sam_img_offset_y[2] - camera.top, samvar.palette);
                else if(samvar.facing == LEFT) draw_sprite_h_flip_palette(output, Sam_Images[2], samvar.x + sam_img_offset_x[2] - camera.lft, samvar.y + sam_img_offset_y[2] - camera.top, samvar.palette);
            }
            else if(samvar.ball_frame < 3) draw_sprite_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top, samvar.palette);
            else if(samvar.ball_frame < 6) draw_sprite_v_flip_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top + 1, samvar.palette);
            else if(samvar.ball_frame < 9) draw_sprite_vh_flip_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top + 1, samvar.palette);
            else if(samvar.ball_frame < 12) draw_sprite_h_flip_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top, samvar.palette);
        }
        else
        {
            if(samvar.facing == RIGHT) draw_sprite_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top, samvar.palette);
            else if(samvar.facing == LEFT) draw_sprite_h_flip_palette(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top, samvar.palette);
            if(samvar.frame == 2 OR samvar.frame == 11 OR samvar.frame == 14 AND !kill_audio) 
            //if(samvar.facing == RIGHT) draw_sprite(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame] - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top);
            //else if(samvar.facing == LEFT) draw_sprite_h_flip(output, Sam_Images[samvar.frame], samvar.x + sam_img_offset_x[samvar.frame]+1  - camera.lft, samvar.y + sam_img_offset_y[samvar.frame] - camera.top);
        }*/
    }
    if(debug_write) printf("S");

    //Acid
    Draw_Water(output, 1);
    if(debug_write) printf("W");

    //Tiles
    Draw_Tiles(output);
    if(debug_write) printf("T");
    Draw_Sprites(output);
    if(debug_write) printf("S");
    Draw_Miniguns(output);
    if(debug_write) printf("M");

    //Bombs
    Draw_Bombs(output);
    if(debug_write) printf("B");

    //Elevators
    Draw_Elevators(output);
    if(debug_write) printf("E");

    //Breakables
    Draw_Breakables(output);
    if(debug_write) printf("B");

    //Items
    Draw_Items(output);
    if(debug_write) printf("I");

    //Doors
    Draw_Doors(output);
    if(debug_write) printf("D");

    //Water
    Draw_Water(output, 0);
    if(debug_write) printf("W");

    //Savezone
    Draw_Savezone(output);
    if(debug_write) printf("S");

    //Foreground Tiles
    //Draw_Foreground_Tiles(output);

    //Heads-up display
    Draw_HUD(output);
    if(debug_write) printf("H");

    //Draw clipping in debug mode
    if(samvar.draw_clips AND Room)
    {
        for(int x = 0; x < Room->xsize*16; x ++)
        {
            for(int y = 0; y < Room->ysize*16; y ++)
            {
                if(     cliparray[x][y] == STOP_SAMUS) putpixel(output, x - camera.lft, y - camera.top, makecol(0, 128, 0)); //Samus only
                else if(cliparray[x][y] == STOP_ENEMY) putpixel(output, x - camera.lft, y - camera.top, makecol(0, 0, 128)); //Enemies only
                else if(cliparray[x][y] == STOP_PROJECTILE) putpixel(output, x - camera.lft, y - camera.top, makecol(128, 0, 128)); //Bullets only
                else if(cliparray[x][y] == STOP_SPRITE) putpixel(output, x - camera.lft, y - camera.top, makecol(128, 0, 128)); //Sprites only
                else if(cliparray[x][y] == 255 - STOP_PROJECTILE) putpixel(output, x - camera.lft, y - camera.top, makecol(0, 0, 255)); //Everything but bullets
                else if(cliparray[x][y] == STOP_FREEZE) putpixel(output, x - camera.lft, y - camera.top, makecol(0, 64, 128)); //Frozen enemy
                else if(cliparray[x][y]) putpixel(output, x - camera.lft, y - camera.top, makecol(0, 255, 0));
            }
        }
    }

    if(samvar.draw_debug == 1) //Doors, Transitions, and Targets
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Doors: %i", total_doors);
        p += 8;
        for(int i = 0; i < total_doors; i ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %s %i %i %i", i, Doors[i].active, Doors[i].name, Doors[i].to_reclose, door_vuln, Doors[i].health);
            p += 8;
        }
        p += 8;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Transitions: %i", total_transitions);
        p += 8;
        for(int i = 0; i < total_transitions; i ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %s %s %s", i, Transitions[i].name, Transitions[i].roomto, Transitions[i].transto);
            p += 8;
            rect(output, Transitions[i].dim.lft - camera.lft, Transitions[i].dim.top - camera.top, Transitions[i].dim.rgt - camera.lft, Transitions[i].dim.bot - camera.top, makecol(0, 0, 255));
        }
        p += 8;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Targets: %i", total_targets);
        p += 8;
        for(int i = 0; i < total_targets; i ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %i %i", i, Targets[i]->active, Targets[i]->hp, *Targets[i]->team);
            p += 8;
        }
        p += 8;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Elevators: %i", total_elevators);
        p += 8;
        for(int i = 0; i < total_elevators; i ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %s", i, Elevators[i].roomto);
            p += 8;
        }
    }
    else if(samvar.draw_debug == 2) //Items
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Items: %i", total_items);
        p += 8;
        for(int i = 0; i < total_items; i ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i:  %i %i %i %i: %i %i", i, Items[i].active, Items[i].expiry, Items[i].x,  Items[i].y, Items[i].type, Items[i].position);
            p += 8;
        }
    }
    else if(samvar.draw_debug == 3) //Savefiles
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Saved Doors: %i", Saveout->doors_saved);
        p += 8;
        for(int y = 0; y < Saveout->doors_saved; y ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: ", y);
            textprintf_ex(output, font, 40, p, makecol(0, 255, 0), -1, "%s %s %i", Saveout->Door_Status_Save[y].doorname, Saveout->Door_Status_Save[y].roomname, Saveout->Door_Status_Save[y].hit_status);

            p += 8;
        }
    }
    else if(samvar.draw_debug == 4) //Enemy Substructures
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Enemies: %i", total_enemies);
        p += 8;
        for(int y = 0; y < total_enemies; y ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i:", y);
            int h = 40;
            for(int q = 0; q < Enemies[y]->size_of_substructure; q ++)
            {
                textprintf_ex(output, font, h, p, makecol(0, 255, 0), -1, "%3i ", Enemies[y]->substructure[q]);
                h += 32;
            }
            p += 8;
        }
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Rinkas: %i", total_rinkas);
        p += 8;
        for(int y = 0; y < total_rinkas; y ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %i", y, Rinka[y].health, Rinka[y].freeze_timer);
            p += 8;
        }
    }
    else if(samvar.draw_debug == 5) //Water
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Water: %i", total_water_zones);
        p += 8;
        for(int y = 0; y < total_water_zones; y ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %i %i", y, Water[y].active, Water[y].dim.top, Water[y].dim.lft);
            rect(output, Water[y].dim.lft - camera.lft, Water[y].dim.top - camera.top, Water[y].dim.rgt - camera.lft, Water[y].dim.bot - camera.top, makecol(0, 0, 255));
            p += 8;
        }
    }
    else if(samvar.draw_debug == 6) //Cambounds
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Cambounds: %i", total_cambounds);
        p += 8;
        for(int y = 0; y < total_cambounds; y ++)
        {
            textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %i %i %i %i %i", y, Cambounds[y].active, Cambounds[y].dim.lft, Cambounds[y].dim.top, Cambounds[y].dim.rgt, Cambounds[y].dim.bot, Cambounds[y].flags);
            rect(output, Cambounds[y].dim.lft - camera.lft, Cambounds[y].dim.top - camera.top, Cambounds[y].dim.rgt - camera.lft, Cambounds[y].dim.bot - camera.top, makecol(255, 255, 0));
            p += 8;
        }
    }
    else if(samvar.draw_debug == 7) //Sprites
    {
        int p = 0;
        textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Sprites: %i", total_sprites);
        p += 8;
        for(int y = 0; y < total_sprites; y ++)
        {
            if(Sprite_List[y]->active)
            {
                textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "%2i: %i %i %i %i", y, Sprite_List[y]->active, Sprite_List[y]->dim.lft, Sprite_List[y]->dim.top, Sprite_List[y]->duration);
                rect(output, Sprite_List[y]->dim.lft - camera.lft, Sprite_List[y]->dim.top - camera.top, Sprite_List[y]->dim.lft - camera.lft+8, Sprite_List[y]->dim.top - camera.top+8, makecol(0, 255, 0)); //Clipping
                p += 8;
            }
            else
            {
                textprintf_ex(output, font, 0, p, makecol(0, 255, 0), -1, "Not active");
                p += 8;
            }
        }
    }
    if(samvar.draw_collision) rect(output, samvar.dim.lft - camera.lft, samvar.dim.top - camera.top, samvar.dim.rgt - camera.lft, samvar.dim.bot - camera.top, makecol(0, 255, 0)); //Clipping
    if(debug_write) printf("D");

    if(game_paused)
    {
        set_trans_blender(0, 0, 0, 128);
        draw_trans_sprite(output, black_buf_old, 0, 0);
        Draw_Box(output, 88, 96, 168, 161);
        textprintf_ex(output, font, 104, 104, makecol( 66,  66, 255), -1, "Paused");
        textprintf_ex(output, font, 104, 116, makecol(168, 228, 252), -1, "Resume");
        textprintf_ex(output, font, 104, 125, makecol(168, 228, 252), -1, "Save");
        textprintf_ex(output, font, 104, 134, makecol(168, 228, 252), -1, "Options");
        textprintf_ex(output, font, 104, 143, makecol(168, 228, 252), -1, "Exit");
        draw_sprite(output, arrow, 96, 116+(pause_cursor)*9);
    }
    if(debug_write) printf("P");
}

void Draw_Background(BITMAP *output)
{
    for(int x = bg_start_x - Background->w; x < output->w + Background->w; x += Background->w)
    {
        for(int y = bg_start_y - Background->h; y < output->h + Background->h; y += Background->h)
        {
            draw_sprite(output, Background, x, y);
        }
    }
}

void Draw_Transition(BITMAP *output)
{
    if(transition_stage == 2)
    {
        clear_to_color(output, 0);
        set_trans_blender(0, 0, 0, 252-transition_counter);
        draw_sprite(output, transition_buffer_old, 0, 0);
        draw_trans_sprite(output, black_buf_old, 0, 0);
    }
    else if(transition_stage == 20)
    {
        set_trans_blender(0, 0, 0, 255);
        draw_sprite(output, transition_buffer_old, 0, -transition_counter);
        draw_trans_sprite(output, black_buf_old, 0, -transition_counter);
    }
    else if(transition_stage == 3)
    {
        set_trans_blender(0, 0, 0, 255);
        if(transition_direction == LEFT)
        {
            draw_sprite(output, transition_buffer_new, -transition_counter, 0);
            draw_trans_sprite(output, black_buf_new, -transition_counter, 0);
            draw_sprite(output, transition_buffer_old, -transition_counter + 256, -vertical_scroll_dif);
            draw_trans_sprite(output, black_buf_old, -transition_counter + 256, -vertical_scroll_dif);
        }
        else if(transition_direction == RIGHT)
        {
            draw_sprite(output, transition_buffer_new, transition_counter, 0);
            draw_trans_sprite(output, black_buf_new, transition_counter, 0);
            draw_sprite(output, transition_buffer_old, transition_counter - 256, -vertical_scroll_dif);
            draw_trans_sprite(output, black_buf_old, transition_counter - 256, -vertical_scroll_dif);
        }
    }
    else if(transition_stage == 4)
    {
        set_trans_blender(0, 0, 0, (transition_counter <= 255? transition_counter : 255));
        draw_sprite(output, transition_buffer_new, 0, 0);
        draw_trans_sprite(output, black_buf_new, 0, 0);
    }
}

void Draw_Tiles(BITMAP *output)
{
    if(Room)
    {
        for(int x = camera.lft / 16; x < (camera.rgt/16)+1; x ++)
        {
            for(int y = camera.top / 16; y < (camera.bot/16)+1; y ++)
            {
                if(x >= 0 AND x <= Room->xsize-1 AND y >= 0 AND y <= Room->ysize-1)
                {
                    if(Room->tiles[x][y]) draw_sprite_palette(output, Tiles[Room->tiles[x][y]-1], x*16 - camera.lft, y*16 - camera.top, cur_palette);
                }
            }
        }
    }
}

void Draw_Foreground_Tiles(BITMAP *output)
{
    if(Room)
    {
        for(int x = camera.lft / 16; x < (camera.rgt/16)+1; x ++)
        {
            for(int y = camera.top / 16; y < (camera.bot/16)+1; y ++)
            {
                if(x >= 0 AND x <= Room->xsize-1 AND y >= 0 AND y <= Room->ysize-1)
                {
                    if(Room->tiles[x][y] == 7 OR Room->tiles[x][y] == 9 OR Room->tiles[x][y] == 15 OR Room->tiles[x][y] == 16) draw_sprite_palette(output, Tiles[Room->tiles[x][y]-1], x*16 - camera.lft, y*16 - camera.top, cur_palette);
                }
            }
        }
    }
}

void Draw_Background_Tiles(BITMAP *output)
{
    if(Room)
    {
        for(int x = camera.lft / 16; x < (camera.rgt/16)+1; x ++)
        {
            for(int y = camera.top / 16; y < (camera.bot/16)+1; y ++)
            {
                if(x >= 0 AND x <= Room->xsize-1 AND y >= 0 AND y <= Room->ysize-1)
                {
                    if(Room->tiles[x][y] != 7 AND Room->tiles[x][y] != 9 AND Room->tiles[x][y] != 15 AND Room->tiles[x][y] != 16 AND Room->tiles[x][y] > 0) draw_sprite_palette(output, Tiles[Room->tiles[x][y]-1], x*16 - camera.lft, y*16 - camera.top, cur_palette);
                }
            }
        }
    }
}

void Draw_Elevators(BITMAP *output)
{
    for(int i = 0; i < total_elevators; i ++)
    {
        draw_sprite_palette(output, Elevator_img, Elevators[i].dim.lft - camera.lft, Elevators[i].dim.top - camera.top + Elevators[i].cur_y, 0);
        if(Elevators[i].in_use) draw_sprite_palette(output, Sam_Frame.Img[SMN_FORWARD], Elevators[i].dim.lft - camera.lft + 8, Elevators[i].dim.top - camera.top + Elevators[i].cur_y - 31, samvar.palette);
    }
}

void Draw_Items(BITMAP *output)
{
    for(int i = 0; i < total_items; i ++)
    {
        if(Items[i].active)
        {
            if(Items[i].fanfare == false)
            {
                if(Items[i].type == 0 OR Items[i].type == 1)
                {
                    if(Items[i].timer < 3) draw_sprite_palette(output, Item_ensmall[0], Items[i].x - camera.lft, Items[i].y - camera.top, 0);
                    else if(Items[i].timer < 6) draw_sprite_palette(output, Item_ensmall[1], Items[i].x - camera.lft, Items[i].y - camera.top, 0);
                }
                else if(Items[i].type == 2)
                {
                    if(Items[i].timer < 3) draw_sprite_palette(output, Item_missile[0], Items[i].x - camera.lft, Items[i].y - camera.top, 0);
                    else if(Items[i].timer < 6) draw_sprite_palette(output, Item_missile[1], Items[i].x - camera.lft, Items[i].y - camera.top, 0);
                }
            }
            else if(Items[i].fanfare == true AND (Items[i].breakable_hook == -1 OR Breakables[Items[i].breakable_hook].show_item))
            {
                if(Items[i].timer < 3) draw_sprite(output, Items[i].bmp0, Items[i].x - camera.lft, Items[i].y - camera.top);
                else if(Items[i].timer < 6) draw_sprite(output, Items[i].bmp1, Items[i].x - camera.lft, Items[i].y - camera.top);
            }
        }
    }
}

void Draw_Doors(BITMAP *output)
{
    for(int i = 0; i < total_doors; i ++)
    {
        if(Doors[i].active AND rect_clip(Doors[i].dim, camera))
        {
            if(Doors[i].openstatus <= 0) //Door is closed
            {
                if(Doors[i].facing == RIGHT)
                {
                    draw_sprite_palette(output, Door_Images[2], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_palette(output, Door_Images[0], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_v_flip_palette(output, Door_Images[2], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
                else if(Doors[i].facing == LEFT)
                {
                    draw_sprite_h_flip_palette(output, Door_Images[2], Doors[i].dim.lft - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_h_flip_palette(output, Door_Images[0], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_vh_flip_palette(output, Door_Images[2], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
            }
            else if(Doors[i].openstatus > 0) //Door is opening
            {
                if(Doors[i].facing == RIGHT)
                {
                    draw_sprite_palette(output, Door_Images[3], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_palette(output, Door_Images[1], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_v_flip_palette(output, Door_Images[3], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
                else if(Doors[i].facing == LEFT)
                {
                    draw_sprite_h_flip_palette(output, Door_Images[3], Doors[i].dim.lft - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_h_flip_palette(output, Door_Images[1], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_vh_flip_palette(output, Door_Images[3], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
            }
            if(samvar.draw_debug) rect(output, Doors[i].dim.lft - camera.lft, Doors[i].dim.top - camera.top, Doors[i].dim.rgt - camera.lft, Doors[i].dim.bot - camera.top, makecol(0, 255, 0));
        }
        else if(Doors[i].to_reclose)
        {
            if(Doors[i].to_reclose < 8) //Door is opening
            {
                if(Doors[i].facing == RIGHT)
                {
                    draw_sprite_palette(output, Door_Images[3], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_palette(output, Door_Images[1], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_v_flip_palette(output, Door_Images[3], Doors[i].dim.rgt-8 - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
                else if(Doors[i].facing == LEFT)
                {
                    draw_sprite_h_flip_palette(output, Door_Images[3], Doors[i].dim.lft - camera.lft, Doors[i].dim.top - camera.top, Doors[i].type);
                    draw_sprite_h_flip_palette(output, Door_Images[1], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+16 - camera.top, Doors[i].type);
                    draw_sprite_vh_flip_palette(output, Door_Images[3], Doors[i].dim.lft - camera.lft, Doors[i].dim.top+32 - camera.top, Doors[i].type);
                }
            }
        }
    }
}

void Draw_Water(BITMAP *output, int flag)
{
    for(int i = 0; i < total_water_zones; i ++)
    {
        if(Water[i].active AND Water[i].type == flag AND rect_clip(Water[i].dim, camera))
        {
            if(Water[i].type == 0)
            {
                set_trans_blender(30, 70, 200, 255);
                draw_lit_sprite(Water[i].bmp2, Water[i].bmp, 0, 0, 128);
                set_trans_blender(0, 0, 0, 64);
                draw_trans_sprite(output, Water[i].bmp2, Water[i].dim.lft-camera.lft, Water[i].dim.top-camera.top);
            }
            else if(Water[i].type == 1)
            {
                draw_sprite(output, Water[i].bmp, Water[i].dim.lft-camera.lft, Water[i].dim.top-camera.top);
            }
        }
    }
}

void Draw_Projectiles(BITMAP *output)
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag != -1 AND Projectiles[i]->bomb == false)
        {
            //Facing right
            if(Projectiles[i]->facing == RIGHT)
            {
                if(!Projectiles[i]->helix_draw)
                    draw_shot_special(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft, Projectiles[i]->dim.top - camera.top, Projectiles[i]->palette, Projectiles[i]->draw);
            }
            else if(Projectiles[i]->facing == LEFT)
            {
                if(!Projectiles[i]->helix_draw)
                    draw_shot_special_h_flip(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft, Projectiles[i]->dim.top - camera.top, Projectiles[i]->palette, Projectiles[i]->draw);
            }
            else if(Projectiles[i]->facing == UP)
            {
                if(!Projectiles[i]->helix_draw)
                    rotate_shot_special(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft + Projectiles[i]->img_offset_x, Projectiles[i]->dim.top - camera.top + Projectiles[i]->img_offset_y, Projectiles[i]->palette, itofix(192), Projectiles[i]->draw);
            }
            if(samvar.draw_collision) rect(output, Projectiles[i]->clip.lft - camera.lft, Projectiles[i]->clip.top - camera.top, Projectiles[i]->clip.rgt - camera.lft, Projectiles[i]->clip.bot - camera.top, makecol(0, 255, 0));
        }
    }
}

void Draw_Bombs(BITMAP *output)
{
    for(int i = 0; i < total_projectiles; i ++)
    {
        if(Projectiles[i]->owner_flag != -1 AND Projectiles[i]->bomb == true)
        {
            //Facing right
            if(Projectiles[i]->facing == RIGHT)
            {
                if(!Projectiles[i]->helix_draw)
                    draw_shot_special(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft, Projectiles[i]->dim.top - camera.top, Projectiles[i]->palette, Projectiles[i]->draw);
            }
            else if(Projectiles[i]->facing == LEFT)
            {
                if(!Projectiles[i]->helix_draw)
                    draw_shot_special_h_flip(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft, Projectiles[i]->dim.top - camera.top, Projectiles[i]->palette, Projectiles[i]->draw);
            }
            else if(Projectiles[i]->facing == UP)
            {
                if(!Projectiles[i]->helix_draw)
                    rotate_shot_special(output, Projectiles[i]->images[Projectiles[i]->image_show], Projectiles[i]->dim.lft - camera.lft + Projectiles[i]->img_offset_x, Projectiles[i]->dim.top - camera.top + Projectiles[i]->img_offset_y, Projectiles[i]->palette, itofix(192), Projectiles[i]->draw);
            }
            if(samvar.draw_collision) rect(output, Projectiles[i]->clip.lft - camera.lft, Projectiles[i]->clip.top - camera.top, Projectiles[i]->clip.rgt - camera.lft, Projectiles[i]->clip.bot - camera.top, makecol(0, 255, 0));
        }
    }
}


void Draw_Enemies(BITMAP *output)
{
    BITMAP *subbmp = NULL;
    for(int i = 0; i < total_enemies; i ++)
    {
        if(Enemies[i]->active)
        {
            if(Enemies[i]->display.images[Enemies[i]->display.to_show])
            {
                subbmp = create_bitmap(Enemies[i]->display.images[Enemies[i]->display.to_show]->xsize, Enemies[i]->display.images[Enemies[i]->display.to_show]->ysize);
                clear_to_color(subbmp, transparent);

                rotate_sprite_palette(subbmp, Enemies[i]->display.images[Enemies[i]->display.to_show], 0, 0, Enemies[i]->palette, itofix(Enemies[i]->display.rotation));

                if(Enemies[i]->display.hflip AND Enemies[i]->display.vflip)
                    draw_sprite_vh_flip(output, subbmp, Enemies[i]->coord.x - camera.lft, Enemies[i]->coord.y - camera.top);
                else if(Enemies[i]->display.hflip)
                    draw_sprite_h_flip(output, subbmp, Enemies[i]->coord.x - camera.lft, Enemies[i]->coord.y - camera.top);
                else if(Enemies[i]->display.vflip)
                    draw_sprite_v_flip(output, subbmp, Enemies[i]->coord.x - camera.lft, Enemies[i]->coord.y - camera.top);
                else
                    draw_sprite(output, subbmp, Enemies[i]->coord.x - camera.lft, Enemies[i]->coord.y - camera.top);

                if(samvar.draw_collision) rect(output, Enemies[i]->bound.lft - camera.lft, Enemies[i]->bound.top - camera.top, Enemies[i]->bound.rgt - camera.lft, Enemies[i]->bound.bot - camera.top, makecol(0, 255, 0)); //Clipping

                destroy_bitmap(subbmp);
            }
        }
    }
    Draw_Rinkas(output);
    Draw_Zebetites(output);
}

void Draw_Sprites(BITMAP *output)
{
    BITMAP *subbmp = NULL;
    for(int i = 0; i < total_sprites; i ++)
    {
        if(Sprite_List[i]->active AND (Sprite_List[i]->frame_num / Sprite_List[i]->frame_denom) < Sprite_List[i]->total_images)
        {
            if(!Sprite_List[i]->draw)
            {
                draw_sprite_palette(output, Sprite_List[i]->images[Sprite_List[i]->frame_num / Sprite_List[i]->frame_denom], Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top, Sprite_List[i]->palette);
            }
            else
            {
                //draw_sprite_palette(output, Sprite_List[i]->images[Sprite_List[i]->frame_num / Sprite_List[i]->frame_denom], Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top, 0);
                int l = Sprite_List[i]->frame_num / Sprite_List[i]->frame_denom;
                subbmp = create_bitmap(Sprite_List[i]->images[l]->xsize, Sprite_List[i]->images[l]->ysize);
                clear_to_color(subbmp, transparent);

                rotate_sprite_palette(subbmp, Sprite_List[i]->images[l], 0, 0, 0, Sprite_List[i]->draw->angle);

                if(Sprite_List[i]->draw->hflip AND Sprite_List[i]->draw->vflip)
                    draw_sprite_vh_flip(output, subbmp, Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top);
                else if(Sprite_List[i]->draw->hflip)
                    draw_sprite_h_flip(output, subbmp, Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top);
                else if(Sprite_List[i]->draw->vflip)
                    draw_sprite_v_flip(output, subbmp, Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top);
                else
                    draw_sprite(output, subbmp, Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top);

                destroy_bitmap(subbmp);
            }
            //if(samvar.draw_collision) rect(output, Sprite_List[i]->dim.lft - camera.lft, Sprite_List[i]->dim.top - camera.top, Sprite_List[i]->dim.rgt - camera.lft, Sprite_List[i]->dim.bot - camera.top, makecol(0, 255, 0)); //Clipping
        }
    }
}

void Draw_HUD(BITMAP *output)
{
    draw_sprite_palette(output, en_display, 24, 26, 0);
    textprintf_ex(output, font, 49, 26, makecol(255, 255, 255), -1, "%i", samvar.energy % 100);
    if(samvar.energy_max > 99)
    {
        int total_tanks = (samvar.energy_max - 99) / 100;
        for(int i = 0; i < total_tanks; i ++)
        {
            rect(output, 24 + (i*10), 16, 32 +(i*10), 24, makecol(68, 60, 255));
            rect(output, 24 + (i*10), 16, 31 +(i*10), 23, makecol(255, 255, 255));
            if(samvar.energy / 100 > i) rectfill(output, 25 + (i*10), 17, 30 +(i*10), 22, makecol(0, 149, 255));
        }
    }
    if(samvar.missiles_max > 0)
    {
        draw_sprite_h_flip_palette(output, Shot_missile, 25, 36, 0);
        textprintf_ex(output, font, 40, 36, makecol(255, 255, 255), -1, "%.3i", samvar.missiles);
    }
    if(escape_active)
    {
        textprintf_ex(output, font, 32, 46, makecol(255, 255, 255), -1, "%i", countdown_timer);
    }

    rectfill(output, 208, 6, 250, 32, black);
    for(int x = 208; x < 250; x += 2)
    {
        putpixel(output, x,  6, white);
        putpixel(output, x, 14, white);
        putpixel(output, x, 22, white);
        putpixel(output, x, 30, white);
    }
    for(int y = 6; y < 32; y += 2)
    {
        putpixel(output, 208, y, white);
        putpixel(output, 216, y, white);
        putpixel(output, 224, y, white);
        putpixel(output, 232, y, white);
        putpixel(output, 240, y, white);
        putpixel(output, 248, y, white);
    }

    if(Curmap)
    {
        Display_Map(output, Curmap, 209, 7, cur_map_pos_x-2, cur_map_pos_y-1);
    }
}

void Draw_Breakables(BITMAP *output)
{
    for(int i = 0; i < total_breakables; i ++)
    {
        if(Breakables[i].active AND Breakables[i].respawn_timer == -1 AND rect_clip(camera, Breakables[i].dim))
        {
            if(Breakables[i].fadein_timer == 0 AND Breakables[i].fadeout_timer == 0) draw_sprite_palette(output, Tiles[Breakables[i].tile_show], Breakables[i].dim.lft - camera.lft, Breakables[i].dim.top - camera.top, cur_palette);
            else if(Breakables[i].fadein_timer < 3) draw_sprite_palette(output, Break_Images[1], Breakables[i].dim.lft - camera.lft, Breakables[i].dim.top - camera.top, cur_palette);
            else if(Breakables[i].fadein_timer < 6) draw_sprite_palette(output, Break_Images[0], Breakables[i].dim.lft - camera.lft, Breakables[i].dim.top - camera.top, cur_palette);
            else if(Breakables[i].fadeout_timer < 3) draw_sprite_palette(output, Break_Images[0], Breakables[i].dim.lft - camera.lft, Breakables[i].dim.top - camera.top, cur_palette);
            else if(Breakables[i].fadeout_timer < 6) draw_sprite_palette(output, Break_Images[1], Breakables[i].dim.lft - camera.lft, Breakables[i].dim.top - camera.top, cur_palette);
        }
    }
}

void Draw_Savezone(BITMAP *output)
{
    if(Savezone.active AND !Samstart.active)
    {
        if(Savezone.show_message)
        {
            Draw_Box(output, 60, 104, 196, 120);
            textprintf_ex(output, font, 65, 109, makecol(168, 228, 252), -1, "Press F3 to save");
        }
        if(Savezone.show_message_saved)
        {
            Draw_Box(output, 84, 104, 172, 120);
            textprintf_ex(output, font, 89, 109, makecol(168, 228, 252), -1, "Game saved");
        }
        if(samvar.draw_collision) rect(output, Savezone.dim.lft-camera.lft, Savezone.dim.top-camera.top, Savezone.dim.rgt-camera.lft, Savezone.dim.bot-camera.top, makecol(0, 128, 0));
    }
}
