void Create_Samus_Frame(int i, char name[], int flip_flag, int offx, int offy)
{
    Sam_Frame.Img[i] = Create_Image_From_MCI(Master_MCI, name, flip_flag);
    Sam_Frame.offx[i] = offx;
    Sam_Frame.offy[i] = offy;
}

void Decide_Samus_Frame_Metroid() //Metroid
{
    int value = 0;
    bool neutral_frame = false;
    if(samvar.press_jump AND !samvar.ball_mode)
    {
        if(samvar.jump AND !samvar.cant_jump)
        {
            if(samvar.jump == 1)
            {
                if(samvar.aim_up) value = SMR_STAND_AUU;
                else value = SMR_STAND_IDLE0;
            }
            else if(samvar.jump == 2) //Mid lift,  frame is run right 1
            {
                if(samvar.aim_up) value = SMR_RUN_AUU1;
                else value = SMR_RUN_IDLE1;
            }
            else if(samvar.jump == 3) //Full jump mode
            {
                if(samvar.aim_up) value = SMR_JUMP_AUU;
                else if(samvar.press_fire)
                {
                    neutral_frame = true;
                    value = SMR_JUMP_SHOOT;
                    if(samvar.facing == LEFT) value = SML_JUMP_SHOOT;
                }
                else value = SMR_JUMP_IDLE0;
            }
        }
    }
    if(samvar.rejump AND samvar.spin_jump > -1 AND !samvar.touch_bot)
    {
        neutral_frame = true;
        if(samvar.spin_jump < 4) value = SMN_SPIN_NORMAL0;
        else if(samvar.spin_jump < 7) value = SMN_SPIN_NORMAL1;
        else if(samvar.spin_jump < 10) value = SMN_SPIN_NORMAL2;
        else if(samvar.spin_jump < 13) value = SMN_SPIN_NORMAL3;
    }
    if(!samvar.touch_bot)
    {
        if(!samvar.jump)
        {
            if(samvar.aim_up) value = SMR_JUMP_AUU;
            else if(samvar.press_fire)
            {
                neutral_frame = true;
                value = SMR_JUMP_SHOOT;
                if(samvar.facing == LEFT) value = SML_JUMP_SHOOT;
            }
            else value = SMR_JUMP_IDLE0;
        }
    }

    if(samvar.spin_jump)
    {
        if((samvar.jump == 0 OR samvar.jump == 3) AND !samvar.shot_cnt AND !samvar.press_fire AND !samvar.disable_spin_draw)
        {
            neutral_frame = true;
            if(samvar.spin_jump < 4) value = SMN_SPIN_NORMAL0;
            else if(samvar.spin_jump < 7) value = SMN_SPIN_NORMAL1;
            else if(samvar.spin_jump < 10) value = SMN_SPIN_NORMAL2;
            else if(samvar.spin_jump < 13) value = SMN_SPIN_NORMAL3;
        }
    }

    if((!samvar.touch_lft AND samvar.press_left) OR (!samvar.touch_rgt AND samvar.press_right)) //Samus is moving left or right
    {
        if(samvar.touch_bot)
        {
            if(samvar.runframe == 0)
            {
                play_footstep_sound = true;
            }
            else
            {
                play_footstep_sound = false;
                has_played_footstep = false;
            }
            if(samvar.aim_up) value = samvar.runframe + SMR_RUN_AUU0;
            else if(samvar.press_fire) value = samvar.runframe + SMR_RUN_ARR0;
            else value = samvar.runframe + SMR_RUN_IDLE0;
        }
    }
    else //Samus is standing still
    {
        if(samvar.touch_bot)
        {
            if(samvar.aim_up) value = SMR_STAND_AUU;
            else value = SMR_STAND_IDLE0;
        }
    }
    if(samvar.ball_mode)
    {
        if(samvar.ball_frame < 0) value = SMR_RUN_IDLE0;
        else if(samvar.ball_frame < 3) value = SMN_BALL0;
        else if(samvar.ball_frame < 6) value = SMN_BALL1;
        else if(samvar.ball_frame < 9) value = SMN_BALL2;
        else if(samvar.ball_frame < 12) value = SMN_BALL3;
        neutral_frame = true;
    }
    if(use_Samstart)
    {
        value = SMN_FORWARD;
        neutral_frame = true;
    }
    frame_flip = false;
    if(!neutral_frame AND samvar.facing == LEFT) value += 82;
    if(neutral_frame AND samvar.facing == LEFT AND value != 211) frame_flip = true;
    Sam_Display = Sam_Frame.Img[value];
    sam_offset_x = Sam_Frame.offx[value];
    sam_offset_y = Sam_Frame.offy[value];
    draw_val = value;
    if(play_footstep_sound AND !has_played_footstep)
    {
        BASS_ChannelPlay(Audio.Footstep, false);
        has_played_footstep = true;
    }
}

void Decide_Samus_Frame_Return() //Metroid 2:  Return of Samus
{
    int value = 0;
    bool neutral_frame = false;
    if(samvar.press_jump AND !samvar.ball_mode)
    {
        if(samvar.jump AND !samvar.cant_jump)
        {
            if(samvar.jump == 1)
            {
                if(samvar.aim_up) value = SMR_STAND_AUU;
                else value = SMR_STAND_IDLE0;
            }
            else if(samvar.jump == 2) //Mid lift,  frame is run right 1
            {
                if(samvar.aim_up) value = SMR_RUN_AUU1;
                else value = SMR_RUN_IDLE0;
            }
            else if(samvar.jump == 3) //Full jump mode
            {
                if(samvar.aim_up) value = SMR_JUMP_AUU;
                else value = SMR_JUMP_IDLE0;
            }
        }
    }
    if(samvar.rejump AND samvar.spin_jump > -1 AND !samvar.touch_bot)
    {
        neutral_frame = true;
        if(samvar.spin_jump < 4) value = SMN_SPIN_NORMAL0;
        else if(samvar.spin_jump < 7) value = SMN_SPIN_NORMAL1;
        else if(samvar.spin_jump < 10) value = SMN_SPIN_NORMAL2;
        else if(samvar.spin_jump < 13) value = SMN_SPIN_NORMAL3;
    }
    if(!samvar.touch_bot)
    {
        if(!samvar.jump)
        {
            if(samvar.aim_up) value = SMR_JUMP_AUU;
            else value = SMR_JUMP_IDLE0;
        }
    }

    if(samvar.spin_jump)
    {
        if((samvar.jump == 0 OR samvar.jump == 3) AND !samvar.shot_cnt AND !samvar.press_fire AND !samvar.disable_spin_draw)
        {
            neutral_frame = true;
            if(samvar.spin_jump < 4) value = SMN_SPIN_NORMAL0;
            else if(samvar.spin_jump < 7) value = SMN_SPIN_NORMAL1;
            else if(samvar.spin_jump < 10) value = SMN_SPIN_NORMAL2;
            else if(samvar.spin_jump < 13) value = SMN_SPIN_NORMAL3;
        }
    }

    if((!samvar.touch_lft AND samvar.press_left) OR (!samvar.touch_rgt AND samvar.press_right)) //Samus is moving left or right
    {
        if(samvar.touch_bot)
        {
            if(samvar.aim_up) value = samvar.runframe + SMR_RUN_AUU0;
            else if(samvar.press_fire) value = samvar.runframe + SMR_RUN_ARR0;
            else value = samvar.runframe + SMR_RUN_IDLE0;
        }
    }
    else //Samus is standing still
    {
        if(samvar.touch_bot)
        {
            if(samvar.aim_up) value = SMR_STAND_AUU;
            else value = SMR_STAND_IDLE0;
        }
        if(samvar.crouch_mode)
        {
            value = SMR_CROUCH_IDLE0;
        }
    }
    if(samvar.ball_mode)
    {
        if(samvar.ball_frame < 0) value = SMR_RUN_IDLE0;
        else if(samvar.ball_frame < 3) value = SMN_BALL0;
        else if(samvar.ball_frame < 6) value = SMN_BALL1;
        else if(samvar.ball_frame < 9) value = SMN_BALL2;
        else if(samvar.ball_frame < 12) value = SMN_BALL3;
        neutral_frame = true;
    }
    if(use_Samstart)
    {
        value = SMN_FORWARD;
        neutral_frame = true;
    }
    frame_flip = false;
    if(!neutral_frame AND samvar.facing == LEFT) value += 82;
    if(neutral_frame AND samvar.facing == LEFT) frame_flip = true;
    Sam_Display = Sam_Frame.Img[value];
    sam_offset_x = Sam_Frame.offx[value];
    sam_offset_y = Sam_Frame.offy[value];
    draw_val = value;
}
