//Pass this function the black mask which is used to fade the room
void Unfade_Tiles(BITMAP *buffer, int mod_dif)
{
    for(int x = camera.lft/16; x < (camera.rgt/16); x ++)
    {
        for(int y = camera.top/16; y < camera.bot/16; y ++)
        {
            if(x < 0) x = 0;
            if(x > Room->xsize-1) x = Room->xsize;
            if(y < 0) y = 0;
            if(y > Room->ysize-1) y = Room->ysize;
            if(Room->tiles[x][y] == 11) //Door tiles, change later
            {
                if(!mod_dif)
                    rectfill(buffer, (x-camera.lft/16)*16, ((y-camera.top/16)*16), (x-camera.lft/16)*16+15, (y-camera.top/16)*16+15, makecol(255, 0, 255));
                else if(mod_dif < 0)
                    rectfill(buffer, (x-camera.lft/16)*16, ((y-camera.top/16)*16) + mod_dif, (x-camera.lft/16)*16+15, (y-camera.top/16)*16+15 + mod_dif, makecol(255, 0, 255));
                else if(mod_dif > 0)
                    rectfill(buffer, (x-camera.lft/16)*16, ((y-camera.top/16)*16) + mod_dif - 16, (x-camera.lft/16)*16+15, (y-camera.top/16)*16+15 + mod_dif - 16, makecol(255, 0, 255));
            }
        }
    }
    printf("mod dif:%i\n", mod_dif);
}
