void Load_Save_File(SAVEFILE *Save, char path[])
{
    FILE *input = fopen(path, "rb");
    if(!input)
    {
        printf("FAILURE:  File %s could not be opened.\n", path);
        return;
    }
    else
    {
        ;//printf("Opening %s\n", path);
    }
    Clear_Save_Data(Save);
    fseek(input, sizeof(char) * 15, SEEK_SET);
    fread(&Save->roomname_len, sizeof(int), 1, input);
    Save->roomname = (char *)malloc(sizeof(char) * (Save->roomname_len+1));
    fread(Save->roomname, sizeof(char) * Save->roomname_len, 1, input);
    fread(&Save->energy, sizeof(int), 1, input);
    fread(&Save->energy_max, sizeof(int), 1, input);
    fread(&Save->missiles, sizeof(int), 1, input);
    fread(&Save->missiles_max, sizeof(int), 1, input);
    fread(&Save->long_beam, sizeof(int), 1, input);
    fread(&Save->charge_beam, sizeof(int), 1, input);
    fread(&Save->ice_beam, sizeof(int), 1, input);
    fread(&Save->wave_beam, sizeof(int), 1, input);
    fread(&Save->spazer_beam, sizeof(int), 1, input);
    fread(&Save->plasma_beam, sizeof(int), 1, input);
    fread(&Save->helix_beam, sizeof(int), 1, input);
    fread(&Save->burn_beam, sizeof(int), 1, input);
    fread(&Save->shock_beam, sizeof(int), 1, input);
    fread(&Save->varia_suit, sizeof(int), 1, input);
    fread(&Save->gravity_suit, sizeof(int), 1, input);
    fread(&Save->morph_ball, sizeof(int), 1, input);
    fread(&Save->bombs, sizeof(int), 1, input);
    fread(&Save->spring_ball, sizeof(int), 1, input);
    fread(&Save->screw_attack, sizeof(int), 1, input);
    fread(&Save->high_jump, sizeof(int), 1, input);
    fread(&Save->space_jump, sizeof(int), 1, input);
    fread(&Save->speed_booster, sizeof(int), 1, input);
    fread(&Save->ridley_dead, sizeof(bool), 1, input);
    fread(&Save->kraid_dead, sizeof(bool), 1, input);
    samvar.energy = Save->energy;
    samvar.energy_max = Save->energy_max;
    samvar.missiles = Save->missiles;
    samvar.missiles_max = Save->missiles_max;

    Update_Saved_Switch(&samvar.Using.long_beam, &samvar.Collected.long_beam, Save->long_beam);
    Update_Saved_Switch(&samvar.Using.charge_beam, &samvar.Collected.charge_beam, Save->charge_beam);
    Update_Saved_Switch(&samvar.Using.ice_beam, &samvar.Collected.ice_beam, Save->ice_beam);
    Update_Saved_Switch(&samvar.Using.wave_beam, &samvar.Collected.wave_beam, Save->wave_beam);
    Update_Saved_Switch(&samvar.Using.spazer_beam, &samvar.Collected.spazer_beam, Save->spazer_beam);
    Update_Saved_Switch(&samvar.Using.plasma_beam, &samvar.Collected.plasma_beam, Save->plasma_beam);
    Update_Saved_Switch(&samvar.Using.helix_beam, &samvar.Collected.helix_beam, Save->helix_beam);
    Update_Saved_Switch(&samvar.Using.burn_beam, &samvar.Collected.burn_beam, Save->burn_beam);
    Update_Saved_Switch(&samvar.Using.shock_beam, &samvar.Collected.shock_beam, Save->shock_beam);
    Update_Saved_Switch(&samvar.Using.varia_suit, &samvar.Collected.varia_suit, Save->varia_suit);
    Update_Saved_Switch(&samvar.Using.gravity_suit, &samvar.Collected.gravity_suit, Save->gravity_suit);
    Update_Saved_Switch(&samvar.Using.morph_ball, &samvar.Collected.morph_ball, Save->morph_ball);
    Update_Saved_Switch(&samvar.Using.bombs, &samvar.Collected.bombs, Save->bombs);
    Update_Saved_Switch(&samvar.Using.spring_ball, &samvar.Collected.spring_ball, Save->spring_ball);
    Update_Saved_Switch(&samvar.Using.screw_attack, &samvar.Collected.screw_attack, Save->screw_attack);
    Update_Saved_Switch(&samvar.Using.high_jump, &samvar.Collected.high_jump, Save->high_jump);
    Update_Saved_Switch(&samvar.Using.space_jump, &samvar.Collected.space_jump, Save->space_jump);
    Update_Saved_Switch(&samvar.Using.speed_booster, &samvar.Collected.speed_booster, Save->speed_booster);
    samvar.ridley_dead = Save->ridley_dead;
    samvar.kraid_dead = Save->kraid_dead;
    //Update_All_Collected_Switches();
    
    fread(&Save->doors_saved, sizeof(int), 1, input);
    Save->Door_Status_Save = (OPENED_DOOR *)malloc(sizeof(OPENED_DOOR) * Save->doors_saved);
    for(int i = 0; i < Save->doors_saved; i ++)
    {
        fread(&Save->Door_Status_Save[i].roomname_len, sizeof(int), 1, input);
        Save->Door_Status_Save[i].roomname = (char *)malloc(sizeof(char) * (Save->Door_Status_Save[i].roomname_len+1));
        fread(Save->Door_Status_Save[i].roomname, sizeof(char) * Save->Door_Status_Save[i].roomname_len, 1, input);
        fread(&Save->Door_Status_Save[i].doorname_len, sizeof(int), 1, input);
        Save->Door_Status_Save[i].doorname = (char *)malloc(sizeof(char) * (Save->Door_Status_Save[i].doorname_len+1));
        fread(Save->Door_Status_Save[i].doorname, sizeof(char) * Save->Door_Status_Save[i].doorname_len, 1, input);
        fread(&Save->Door_Status_Save[i].hit_status, sizeof(int), 1, input);
    }
    fread(&Save->objects_saved, sizeof(int), 1, input);
    Save->Object_Status_Save = (SAVED_OBJECT *)malloc(sizeof(SAVED_OBJECT) * Save->objects_saved);
    for(int i = 0; i < Save->objects_saved; i ++)
    {
        fread(&Save->Object_Status_Save[i].roomname_len, sizeof(int), 1, input);
        Save->Object_Status_Save[i].roomname = (char *)malloc(sizeof(char) * (Save->Object_Status_Save[i].roomname_len+1));
        fread(Save->Object_Status_Save[i].roomname, sizeof(char) * Save->Object_Status_Save[i].roomname_len, 1, input);
        fread(&Save->Object_Status_Save[i].object_pos, sizeof(int), 1, input);
    }

    //Maps
    fread(&Save->maps_accessed, sizeof(int), 1, input);
    Save->Savemap = (SAVEMAP *)malloc(sizeof(MAP) * Save->maps_accessed);
    for(int i = 0; i < Save->maps_accessed; i ++)
    {
        fread(&Save->Savemap[i].name_len, sizeof(int), 1, input);
        Save->Savemap[i].name = (char *)malloc(sizeof(char) * Save->Savemap[i].name_len+1);
        fread(Save->Savemap[i].name, sizeof(char) * Save->Savemap[i].name_len, 1, input);

        int mapnum = -1;
        for(int q = 0; q < total_maps; q ++)
        {
            if(!strcmp(Maps[q]->name, Save->Savemap[i].name)) mapnum = q;
        }

        fread(&Save->Savemap[i].xsize, sizeof(int), 1, input);
        fread(&Save->Savemap[i].ysize, sizeof(int), 1, input);
        Save->Savemap[i].vals = (short **)malloc(sizeof(short *) * Save->Savemap[i].xsize);
        for(int x = 0; x < Save->Savemap[i].xsize; x ++)
        {
            Save->Savemap[i].vals[x] = (short *)malloc(sizeof(short) * Save->Savemap[i].ysize);
            for(int y = 0; y < Save->Savemap[i].ysize; y ++)
            {
                fread(&Save->Savemap[i].vals[x][y], sizeof(short), 1, input);
                if(mapnum != -1) Maps[mapnum]->vals[x][y] = Save->Savemap[i].vals[x][y];
            }
        }
    }
    fclose(input);

    if(!samvar.missile_mode)
    {
        if(samvar.Using.gravity_suit) samvar.palette = 4;
        else if(samvar.Using.varia_suit) samvar.palette = 2;
        else samvar.palette = 0;
        samvar.qpalette = samvar.palette;
    }
    else
    {
        if(samvar.Using.gravity_suit) samvar.palette = 5;
        else if(samvar.Using.varia_suit) samvar.palette = 3;
        else samvar.palette = 1;
        samvar.qpalette = samvar.palette;
    }
    subscreen_up = false;
}
