void Initialize_Everything()
{
    allegro_init();
    //al_install_audio();
    install_keyboard();
    install_timer();
    set_keyboard_rate(0, 0);

	CVars = (CVAR *)malloc(sizeof(CVAR) * 64);
	
    Init_Script_Engine(SCRIPTS"Globals.msf");

    //Sound stuff
    int audio_ok = BASS_Init(-1, 44100, 0, 0, NULL);
	if (!audio_ok) {
		printf("BASS Init error=%i", BASS_ErrorGetCode());
	}

    Audio.Brinstar_Music = BASS_StreamCreateFile(FALSE, SOUND"Brinstar Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Norfair_Music = BASS_StreamCreateFile(FALSE, SOUND"Norfair Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Ridley_Music = BASS_StreamCreateFile(FALSE, SOUND"Ridley's Lair Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Red_Brinstar_Music = BASS_StreamCreateFile(FALSE, SOUND"Red Brinstar Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Kraid_Music = BASS_StreamCreateFile(FALSE, SOUND"Kraid's Lair Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Tourian_Music = BASS_StreamCreateFile(FALSE, SOUND"Tourian Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Item_Music = BASS_StreamCreateFile(FALSE, SOUND"Item Room Music.ogg", 0, 0, BASS_SAMPLE_LOOP);
    Audio.Get_Item_Music = BASS_StreamCreateFile(FALSE, SOUND"Item Collect.ogg", 0, 0, 0);
    Audio.Escape_Music = BASS_StreamCreateFile(FALSE, SOUND"Escape Music.ogg", 0, 0, BASS_SAMPLE_LOOP);

    Audio.Acid = BASS_StreamCreateFile(FALSE, SOUND"Acid.ogg", 0, 0, 0);
    Audio.Samus_Hurt = BASS_StreamCreateFile(FALSE, SOUND"Samus Hurt.ogg", 0, 0, 0);
    Audio.Normal_Beam = BASS_StreamCreateFile(FALSE, SOUND"Normal Beam.ogg", 0, 0, 0);
    Audio.Long_Beam = BASS_StreamCreateFile(FALSE, SOUND"Long Beam.ogg", 0, 0, 0);
    Audio.Ice_Beam = BASS_StreamCreateFile(FALSE, SOUND"Ice Beam.ogg", 0, 0, 0);
    Audio.Wave_Beam = BASS_StreamCreateFile(FALSE, SOUND"Wave Beam.ogg", 0, 0, 0);
    Audio.Spazer_Beam = BASS_StreamCreateFile(FALSE, SOUND"Spazer.ogg", 0, 0, 0);
    Audio.Injured_Small = BASS_StreamCreateFile(FALSE, SOUND"Injured1.ogg", 0, 0, 0);
    Audio.Injured_Large = BASS_StreamCreateFile(FALSE, SOUND"Injured2.ogg", 0, 0, 0);
    Audio.Injured_Boss = BASS_StreamCreateFile(FALSE, SOUND"Injured3.ogg", 0, 0, 0);
    Audio.Injured_Metroid = BASS_StreamCreateFile(FALSE, SOUND"Injured4.ogg", 0, 0, 0);
    Audio.Invuln = BASS_StreamCreateFile(FALSE, SOUND"Invuln.ogg", 0, 0, 0);
    Audio.Jump = BASS_StreamCreateFile(FALSE, SOUND"Jump.ogg", 0, 0, 0);
    Audio.Loading = BASS_StreamCreateFile(FALSE, SOUND"Loading.ogg", 0, 0, 0);
    Audio.Get_Missile = BASS_StreamCreateFile(FALSE, SOUND"Get Missile.ogg", 0, 0, 0);
    Audio.Get_Energy = BASS_StreamCreateFile(FALSE, SOUND"Get Energy.ogg", 0, 0, 0);
    Audio.Door_Open = BASS_StreamCreateFile(FALSE, SOUND"Door Open.ogg", 0, 0, 0);
    Audio.Drop_Bomb = BASS_StreamCreateFile(FALSE, SOUND"Drop Bomb.ogg", 0, 0, 0);
    Audio.Bomb_Explode = BASS_StreamCreateFile(FALSE, SOUND"Bomb Explode.ogg", 0, 0, 0);
    Audio.Missile_Fire = BASS_StreamCreateFile(FALSE, SOUND"Missile Fire.ogg", 0, 0, 0);
    Audio.Footstep = BASS_StreamCreateFile(FALSE, SOUND"Footstep.ogg", 0, 0, 0);
    Audio.Morph = BASS_StreamCreateFile(FALSE, SOUND"Morph.ogg", 0, 0, 0);

    Cur_Music = NULL;

    LOCK_VARIABLE(speed_counter);
    LOCK_FUNCTION(increment_speed_counter);
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(60));
    srand((unsigned)time(NULL));

    printf("[-]     Beginning CVar Data dump     [-] \n");
    Create_CVar_List();
    Read_Config_File("SMTC.cfg");
    if(strcmp(Get_Cvar_Value_C("campaign"), "DONGS"))
    {
        campaign_mode = true;
    }
    printf("[-]         End of CVar data         [-] \n\n");
    screen_var = Get_Cvar_Value_I("screen_size");

    if(Get_Cvar_Value_I("color_depth") == 0) set_color_depth(24);
    else if(Get_Cvar_Value_I("color_depth") == 1) set_color_depth(32);
    else set_color_depth(32);
    game_version = Get_Cvar_Value_I("game_version");
    int array_x[6];
    int array_y[6];
    array_x[0] =  256;
    array_x[1] =  640;
    array_x[2] =  800;
    array_x[3] = 1024;
    array_x[4] = 1152;
    array_x[5] = 1280;

    array_y[0] =  256;
    array_y[1] =  480;
	#ifdef PANDORA
    array_y[2] =  480;
	#else
    array_y[2] =  600;
	#endif
    array_y[3] =  768;
    array_y[4] =  864;
    array_y[5] = 1024;
    if(screen_var > -1 AND screen_var < 6)
    {
        if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, array_x[screen_var], array_y[screen_var], 0,0))
        {
            printf("Screen failed to set GFX mode!\n");
            exit(0);
        }
    }
    else if(screen_var > 5 AND screen_var < 12)
    {
        if(set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, array_x[screen_var-6], array_y[screen_var-6], 0,0))
        {
            printf("Screen failed to set GFX mode!\n");
            exit(0);
        }
    }
    else
    {
		#ifdef PANDORA
        if(set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800, 480, 0,0))
		#else
        if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, 256, 256, 0,0))
		#endif
        {
            printf("Screen failed to set GFX mode!\n");
            exit(0);
        }
    }
    int q = set_display_switch_mode(SWITCH_BACKGROUND);

    transparent = makecol(255, 0, 255);
    white = makecol(255, 255, 255);

    Create_Keylist();
    Create_Control_List();

    printf("+++     Beginning MCI Data dump      +++\n");
	Master_MCI = Open_MCI_File(IMAGES"Images.mci");
    Load_Datafile_Images();
    Load_ISF_Images();
    if(game_version == 1) Load_Samus_Images_One();
    else if(game_version == 2) Load_Samus_Images_Two();
    Load_Enemy_Images();
    printf("+++         End of MCI Data          +++\n\n");

    buffer = create_bitmap(256, 256);
    bg_start_x = 0;
    bg_start_y = 0;
    bg_scroll_factor_x = 16;
    bg_scroll_factor_y = 16;
    bg_scroll_pos_x = 0;
    bg_scroll_pos_y = 0;
    Saveout = (SAVEFILE *)malloc(sizeof(SAVEFILE));
    Saveout->roomname = NULL;
    Saveout->doors_saved = 0;
    Saveout->objects_saved = 0;
    Saveout->Object_Status_Save = NULL;
    Saveout->Door_Status_Save = NULL;
    Saveout->Savemap = NULL;
    Saveout->maps_accessed = 0;
    Saveout_path = (char *)malloc(sizeof(char) * 80);
    Init_String(Saveout_path, SAVES"Save.ssf", 15);

    transition_buffer_old = create_bitmap(256, 256);
    black_buf_old = create_bitmap(256, 256);
    transition_buffer_new = create_bitmap(256, 256);
    black_buf_new = create_bitmap(256, 256);

    water_array[0] = 0;
    water_array[1] = 1;
    water_array[2] = 2;
    water_array[3] = 2;
    water_array[4] = 1;
    water_array[5] = 0;

    //Samus setup
    if(Get_Cvar_Value_I("debug_mode") == 1)
    {
        debug_mode = true;
    }
    else
    {
        debug_mode = false;
    }
	Initialize_Samus();
    //Recolor Pack
    //Samus_Recolor = Create_Recolor(3, makecol(255, 145, 95), makecol(255, 55, 26), makecol(60, 123, 0)); //Body, Helmet, Visor
    //Add_Palette(&Samus_Recolor, makecol(255, 145,  95), makecol(255, 55, 26), makecol( 0, 217, 255)); //Missile Mode
    //Add_Palette(&Samus_Recolor, makecol(252, 196, 219), makecol(255, 55, 26), makecol(60, 123,   0)); //Varia Suit
    //Add_Palette(&Samus_Recolor, makecol(252, 196, 219), makecol(255, 55, 26), makecol( 0, 217, 255)); //Varia Suit with Missiles
    //Add_Palette(&Samus_Recolor, makecol(244, 120, 252), makecol(255, 55, 26), makecol(60, 123,   0)); //Gravity Suit
    //Add_Palette(&Samus_Recolor, makecol(244, 120, 252), makecol(255, 55, 26), makecol( 0, 217, 255)); //Gravity Suit with Missiles

    for(int i = 0; i < 18; i ++)
    {
        Subscreen_Item[i].exclusive_total = 0;
        Subscreen_Item[i].exclusive = NULL;
    }
    Map_Recolor = Create_Recolor(2, makecol(216, 56, 144), white);
    Add_Palette(&Map_Recolor, makecol(248, 176, 0), makecol(255, 45, 45));

    //Subscreen Setup
    Create_Subscreen_Item(14,  32,  65,  71,  72, &samvar.Collected.long_beam, &samvar.Using.long_beam, "LONG");
    Create_Subscreen_Item( 0,  32,  73,  71,  80, &samvar.Collected.charge_beam, &samvar.Using.charge_beam, "CHARGE");
    Create_Subscreen_Item( 3,  32,  81,  71,  88, &samvar.Collected.spazer_beam, &samvar.Using.spazer_beam, "SPAZER");
    Make_Exclusive_With(3, 4);
    Make_Exclusive_With(3, 15);
    Create_Subscreen_Item( 4,  32,  89,  71,  96, &samvar.Collected.plasma_beam, &samvar.Using.plasma_beam, "PLASMA");
    Make_Exclusive_With(4, 3);
    Make_Exclusive_With(4, 15);
    Make_Exclusive_With(4, 16);
    Make_Exclusive_With(4, 17);
    Create_Subscreen_Item(15,  32,  97,  71, 104, &samvar.Collected.helix_beam, &samvar.Using.helix_beam, "HELIX");
    Make_Exclusive_With(15, 3);
    Make_Exclusive_With(15, 4);
    Make_Exclusive_With(15, 2);
    Set_Item_Path(14, -1, -1,  5,  0);
    Set_Item_Path( 0, -1, 14,  6,  3);
    Set_Item_Path( 3, -1,  0,  7,  4);
    Set_Item_Path( 4, -1,  3,  8, 15);
    Set_Item_Path(15, -1,  4,  9,  1);

    Create_Subscreen_Item( 1,  32, 121,  71, 128, &samvar.Collected.ice_beam, &samvar.Using.ice_beam, "ICE");
    Make_Exclusive_With(1, 16);
    Create_Subscreen_Item(16,  32, 129,  71, 137, &samvar.Collected.burn_beam, &samvar.Using.burn_beam, "BURN");
    Make_Exclusive_With(16, 1);
    Make_Exclusive_With(16, 4);
    Set_Item_Path( 1, -1, 15, 10, 16);
    Set_Item_Path(16, -1,  1, 11,  2);

    Create_Subscreen_Item( 2,  32, 153,  71, 160, &samvar.Collected.wave_beam, &samvar.Using.wave_beam, "WAVE");
    Make_Exclusive_With(2, 17);
    Make_Exclusive_With(2, 15);
    Create_Subscreen_Item(17,  32, 161,  71, 168, &samvar.Collected.shock_beam, &samvar.Using.shock_beam, "SHOCK");
    Make_Exclusive_With(17, 2);
    Make_Exclusive_With(17, 4);
    Set_Item_Path( 2, -1, 16, 12, 17);
    Set_Item_Path(17, -1,  2, 13, -1);

    Create_Subscreen_Item( 5, 168,  72, 239,  79, &samvar.Collected.varia_suit, &samvar.Using.varia_suit, "VARIA");
    Create_Subscreen_Item( 6, 168,  80, 239,  87, &samvar.Collected.gravity_suit, &samvar.Using.gravity_suit, "GRAVITY");
    Set_Item_Path( 5, 14, -1, -1, 6);
    Set_Item_Path( 6,  0,  5, -1, 7);

    Create_Subscreen_Item( 7, 168, 104, 239, 111, &samvar.Collected.morph_ball, &samvar.Using.morph_ball, "MORPHINGBALL");
    Create_Subscreen_Item( 8, 168, 112, 239, 119, &samvar.Collected.bombs, &samvar.Using.bombs, "BOMB");
    Create_Subscreen_Item( 9, 168, 120, 239, 127, &samvar.Collected.screw_attack, &samvar.Using.screw_attack, "SCREW ATTACK");
    Create_Subscreen_Item(10, 168, 128, 239, 135, &samvar.Collected.spring_ball, &samvar.Using.spring_ball, "SPRING BALL");
    Set_Item_Path( 7,  3,  6, -1,  8);
    Set_Item_Path( 8,  4,  7, -1,  9);
    Set_Item_Path( 9, 15,  8, -1, 10);
    Set_Item_Path(10,  1,  9, -1, 11);

    Create_Subscreen_Item(11, 168, 152, 239, 159, &samvar.Collected.high_jump, &samvar.Using.high_jump, "HIGH JUMP");
    Create_Subscreen_Item(12, 168, 160, 239, 167, &samvar.Collected.speed_booster, &samvar.Using.speed_booster, "SPEED BOOSTER");
    Create_Subscreen_Item(13, 168, 168, 239, 175, &samvar.Collected.space_jump, &samvar.Using.space_jump, "SPACE JUMP");
    Set_Item_Path(11, 16, 10, -1, 12);
    Set_Item_Path(12,  2, 11, -1, 13);
    Set_Item_Path(13, 17, 12, -1, -1);

    subscreen_black_buffer = create_bitmap(256, 256);
    clear_to_color(subscreen_black_buffer, 0);

    //Map Setup
    total_maps = 7;
    Maps = (MAP **)malloc(sizeof(MAP *) * total_maps);
    Maps[0] = Create_Map("Red Brinstar", 18, 12, load_bitmap(IMAGESMAPS"Red_Brinstar_Map.bmp", NULL));
    Maps[1] = Create_Map("Brinstar", 33, 20, load_bitmap(IMAGESMAPS"Brinstar_Map.bmp", NULL));
    Maps[2] = Create_Map("Kraid", 16, 17, load_bitmap(IMAGESMAPS"Kraid_Map.bmp", NULL));
    Maps[3] = Create_Map("Tourian", 14, 13, load_bitmap(IMAGESMAPS"Tourian_Map.bmp", NULL));
    Maps[4] = Create_Map("Norfair", 22, 17, load_bitmap(IMAGESMAPS"Norfair_Map.bmp", NULL));
    Maps[5] = Create_Map("Ridley", 21, 11, load_bitmap(IMAGESMAPS"Ridley_Map.bmp", NULL));
    Maps[6] = Create_Map("Depths", 20, 10, load_bitmap(IMAGESMAPS"Depths_Map.bmp", NULL));
    map_cursor = (BITMAP *)Image_Datafile[5].dat;

    //Setup beam lookup table
    for(int i = 0; i < 36; i ++)
    {
        projectile_lookup_table[i] = sin((float)(i)*PI/180.0*20);
    }

    if(campaign_mode)
    {
        Initialize_Campaign(Get_Cvar_Value_C("campaign"));
    }

}

void Use_Command_Line(int argc, char *argv[])
{
    printf("---      Command line data dump      ---\n");
    for(int i = 0; i < argc; i ++)
    {
        printf("Line %i: %s\n", i, argv[i]);
        if(!strncmp(argv[i], "-nosound", 8))
        {
            int p = BASS_Pause();
            if(p) printf("  Stopping music\n");
        }
        if(!strncmp(argv[i], "-noterminate", 12))
        {
            int p = BASS_Pause();
            if(p) printf("  Stopping music\n");
        }
        if(!strncmp(argv[i], "-debwrite", 9))
        {
            debug_write = true;
        }
    }
    printf("---     End of command line data     ---\n\n");
}

void Create_Keylist()
{
    total_keys = 101;
    Keylist = (KEYLIST *)malloc(sizeof(KEYLIST) * total_keys);
    //Alphabet
    for(int i = 0; i < 26; i ++)
    {
        Keylist[i].name[0] = 65 + i;
        Keylist[i].name[1] = 0;
        Keylist[i].key = (char *)&key[i+1];
        Keylist[i].askey = i + 97;
        Keylist[i].shkey = i + 65;
    }
    //Numbers
    for(int i = 0; i < 10; i ++)
    {
        Keylist[i+26].name[0] = 48 + i;
        Keylist[i+26].name[1] = 0;
        Keylist[i+26].key = (char *)&key[i+27];
        Keylist[i+26].askey = i + 48;
    }
    Keylist[26].shkey = ')';
    Keylist[27].shkey = '!';
    Keylist[28].shkey = '@';
    Keylist[29].shkey = '#';
    Keylist[30].shkey = '$';
    Keylist[31].shkey = '%';
    Keylist[32].shkey = '^';
    Keylist[33].shkey = '&';
    Keylist[34].shkey = '*';
    Keylist[35].shkey = '(';
    //Number pad
    for(int i = 0; i < 10; i ++)
    {
        Keylist[i+36].name[0] = 48 + i;
        Keylist[i+36].name[1] = 'P';
        Keylist[i+36].name[2] = 'A';
        Keylist[i+36].name[3] = 'D';
        Keylist[i+36].name[4] = 0;
        Keylist[i+36].askey = Keylist[i+26].askey;
        Keylist[i+36].shkey = Keylist[i+26].askey;
        Keylist[i+36].key = (char *)&key[i+37];
    }
    //Function keys
    for(int i = 1; i < 10; i ++)
    {
        Keylist[i+45].name[0] = 'F';
        Keylist[i+45].name[1] = 48 + i;
        Keylist[i+45].name[2] = 0;
        Keylist[i+45].key = (char *)&key[i+46];
        Keylist[i+45].askey = '^';
        Keylist[i+45].shkey = '^';
    }
    int c = 56;
    int v = 55;
    Create_Key("F10", (char *)&key[c], '^', '^', &c, &v);
    Create_Key("F11", (char *)&key[c], '^', '^', &c, &v);
    Create_Key("F12", (char *)&key[c], '^', '^', &c, &v);

    Create_Key("Esc", (char *)&key[c], '^', '^', &c, &v);
    Create_Key("Tilde", (char *)&key[c], '~', '~', &c, &v);
    Create_Key("Minus", (char *)&key[c], '-', '_', &c, &v);
    Create_Key("Equals", (char *)&key[c], '=', '+', &c, &v);
    Create_Key("Bckspce", (char *)&key[c], 8, 8, &c, &v);
    Create_Key("Tab", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Obrace", (char *)&key[c], '[', '{', &c, &v);
    Create_Key("CBrace", (char *)&key[c], ']', '}', &c, &v);
    Create_Key("Enter", (char *)&key[c], 13, 13, &c, &v);
    Create_Key("Colon", (char *)&key[c], ';', ':', &c, &v);
    Create_Key("Quote", (char *)&key[c], '\'', '\"', &c, &v);
    Create_Key("Bkslsh", (char *)&key[c], '\\', '|', &c, &v);
    Create_Key("Bkslsh2", (char *)&key[c], '\\', '\\', &c, &v);
    Create_Key("Comma", (char *)&key[c], ',', '<', &c, &v);
    Create_Key("Stop", (char *)&key[c], '.', '>', &c, &v);
    Create_Key("Slash", (char *)&key[c], '/', '?', &c, &v);
    Create_Key("Space", (char *)&key[c], ' ', ' ', &c, &v);
    Create_Key("Insert", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Del", (char *)&key[c], 8, 8, &c, &v);
    Create_Key("Home", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("End", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("PGUp", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("PGDown", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Left", (char *)&key[c], 8, 8, &c, &v);
    Create_Key("Right", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Up", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Down", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("SlshPAD", (char *)&key[c], '/', '/', &c, &v);
    Create_Key("AstrPAD", (char *)&key[c], '*', '*', &c, &v);
    Create_Key("MnusPAD", (char *)&key[c], '-', '-', &c, &v);
    Create_Key("PlusPAD", (char *)&key[c], '+', '+', &c, &v);
    Create_Key("DelPAD", (char *)&key[c], 8, 8, &c, &v);
    Create_Key("EntrPAD", (char *)&key[c], 13, 13, &c, &v);
    Create_Key("PrtScr", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Pause", (char *)&key[c], 0, 0, &c, &v);
    c = 103;
    Create_Key("LftShft", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("RgtShft", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("LftCtrl", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("RgtCtrl", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Alt", (char *)&key[c], 0, 0, &c, &v);
    Create_Key("Caplock", (char *)&key[112], 0, 0, &c, &v);
    Create_Key("Numlock", (char *)&key[113], 0, 0, &c, &v);
    Create_Key("Scrlock", (char *)&key[114], 0, 0, &c, &v);
}

void Create_Control_List()
{
	#ifdef PANDORA
    Create_Control("Jump", "PGDown", &keys.jump);
    Create_Control("Shoot", "End", &keys.fire);
    Create_Control("ISwitch", "PGUp", &keys.switchitem);
	#else
    Create_Control("Jump", "Z", &keys.jump);
    Create_Control("Shoot", "X", &keys.fire);
    Create_Control("ISwitch", "A", &keys.switchitem);
	#endif
    Create_Control("Left", "Left", &keys.left);
    Create_Control("Right", "Right", &keys.right);
    Create_Control("Up", "Up", &keys.up);
    Create_Control("Down", "Down", &keys.down);

	#ifdef PANDORA
    Create_Control("LShoulder", "RgtShft", &keys.lshoulder);
    Create_Control("RShoulder", "RgtCtrl", &keys.rshoulder);
	#else
    Create_Control("LShoulder", "Q", &keys.lshoulder);
    Create_Control("RShoulder", "W", &keys.rshoulder);
	#endif

    Create_Control("Debug1", "C", &keys.clip_draw);
    Create_Control("Debug2", "D", &keys.debug_draw);
    Create_Control("Debug3", "E", &keys.collision_draw);

    Create_Control("SubScreen", "Enter", &keys.start);
    Create_Control("ICancel" , "S", &keys.cancel);
    Create_Control("Speed", "Tilde", &keys.speed);
    Create_Control("Slow", "BckSpce", &keys.slow);
    Create_Control("Quit", "Esc", &keys.quit);

    Create_Control("ScrnShot", "F2", &keys.screen_shot);
    Create_Control("FramPlus", "PlusPAD", &keys.frame_plus);
    Create_Control("FramMnus", "MnusPAD", &keys.frame_minus);
    Create_Control("Save", "F3", &keys.saveout);

    keys.jump       = 0;
    keys.fire       = 1;
    keys.switchitem = 2;
    keys.left       = 3;
    keys.right      = 4;
    keys.up         = 5;
    keys.down       = 6;
    keys.lshoulder  = 7;
    keys.rshoulder  = 8;
    keys.clip_draw  = 9;
    keys.debug_draw = 10;
    keys.collision_draw  = 11;

    keys.start = 12;
    keys.cancel = 13;

    keys.speed = 14;
    keys.slow  = 15;
    keys.quit  = 16;

    keys.screen_shot = 17;

    keys.frame_plus = 18;
    keys.frame_minus = 19;
    keys.saveout = 20;
}

void Create_CVar_List()
{
    Create_CVar_C("st", "Rooms/Test3.mcl");
    Create_CVar_C("campaign", "DONGS");
    Create_CVar_I("skipintro", false);
	#ifdef PANDORA
    Create_CVar_I("esc_quits", true);
	#else
    Create_CVar_I("esc_quits", false);
	#endif
    Create_CVar_I("door_missiles_mode", false);
    Create_CVar_I("complex_water", true);
    Create_CVar_I("total_tiles", 180);
	#ifdef PANDORA
    Create_CVar_I("screen_size", 2+6);
	#else
    Create_CVar_I("screen_size", 0);
	#endif
    Create_CVar_I("color_depth", 0);
    Create_CVar_I("fireworks_mode", 1);
    Create_CVar_I("debug_mode", 0);
    Create_CVar_I("megaman_mode", 0);
    Create_CVar_I("megaman_tiles", 80);
    Create_CVar_I("game_version", 1);
}

void Initialize_Campaign(char path[])
{
    printf("Loading Campaign base data from %s... ", path);
    FILE *infile = fopen(path, "rb");
    if(!infile)
    {
        printf("Campaign failed to load\n");
        return;
    }

    if(Campaign) free(Campaign);
    Campaign = (CAMPAIGN *)malloc(sizeof(CAMPAIGN));

    Campaign->version = (char *)malloc(sizeof(char) * 20);

    //Campaign data
    fread(Campaign->version, sizeof(char), 20, infile);
    fread(&Campaign->total_rooms, sizeof(int), 1, infile);
    Campaign->room_pos_info = (int *)malloc(sizeof(int) * Campaign->total_rooms);
    fread(Campaign->room_pos_info, sizeof(int), Campaign->total_rooms, infile);
    Campaign->room_names = (char **)malloc(sizeof(char *) * Campaign->total_rooms);
    for(int i = 0; i < Campaign->total_rooms; i ++)
    {
        int w = 0;
        char inbyte = -1;
        while(inbyte != 0)
        {
            w ++;
            fread(&inbyte, sizeof(char), 1, infile);
        }
        fseek(infile, -(w), SEEK_CUR);

        Campaign->room_names[i] = (char *)malloc(sizeof(char) * w+1);
        fread(Campaign->room_names[i], sizeof(char), w, infile);
    }
    printf("Done\n");
}

void Initialize_Samus()
{
	memset(&samvar, 0, sizeof(samvar));
    samvar.x = 64;
    samvar.y = 64;
    samvar.energy = 99;
    samvar.energy_max = 99;
    if(debug_mode)
    {
        samvar.missiles = 100;
        samvar.missiles_max = 100;
    }
    else
    {
        samvar.missiles = 0;
        samvar.missiles_max = 0;
    }
    Update_All_Collected_Switches();

    samvar.cant_jump = false;
    Update_Samus_Clips();
    samvar.frame = 0;
    samvar.facing = 0;
    samvar.launch_height = -1;
    samvar.missile_mode = false;
    samvar.palette = 0;
    samvar.qpalette = samvar.palette;

    camera.lft = 0;
    camera.rgt = 256;
    camera.top = 0;
    camera.bot = 256;

    Ridley.active = false;
    Kraid.active = false;
    for(int i = 0; i < 5; i ++)
    {
        Ridley.Fireball[i].active = false;
    }
}