void Create_Sprite_Spawner(int x, int y, int images, int cooldown, int offset, void (*hookfunc)(int))
{
    bool failflag = false;
    for(int i = 0; i < total_sprite_spawners; i ++)
    {
        if(!Sprite_Spawner[i]->active)
        {
            Sprite_Spawner[i]->active = true;
            Sprite_Spawner[i]->x = x;
            Sprite_Spawner[i]->y = y;
            Sprite_Spawner[i]->images = images;
            Sprite_Spawner[i]->cooldown_num = offset;
            Sprite_Spawner[i]->cooldown_denom = cooldown;
            Sprite_Spawner[i]->hookfunc = hookfunc;
            i = total_sprite_spawners;
            failflag = true;
        }
    }
    if(!failflag)
    {
        Sprite_Spawner = (SPRITE_SPAWNER **)realloc(Sprite_Spawner, sizeof(SPRITE_SPAWNER *) * (total_sprite_spawners + 1));
        Sprite_Spawner[total_sprite_spawners] = (SPRITE_SPAWNER *)malloc(sizeof(SPRITE_SPAWNER)+8);
        Sprite_Spawner[total_sprite_spawners]->active = true;
        Sprite_Spawner[total_sprite_spawners]->x = x;
        Sprite_Spawner[total_sprite_spawners]->y = y;
        Sprite_Spawner[total_sprite_spawners]->images = images;
        Sprite_Spawner[total_sprite_spawners]->cooldown_num = offset;
        Sprite_Spawner[total_sprite_spawners]->cooldown_denom = cooldown;
        Sprite_Spawner[total_sprite_spawners]->hookfunc = hookfunc;
        total_sprite_spawners ++;
    }
}

void Update_Spawners()
{
    //Sprite Spawners
    for(int i = 0; i < total_sprite_spawners; i ++)
    {
        if(Sprite_Spawner[i]->active)
        {
            Sprite_Spawner[i]->cooldown_num ++;
            if(Sprite_Spawner[i]->cooldown_num >= Sprite_Spawner[i]->cooldown_denom)
            {
                Sprite_Spawner[i]->cooldown_num = 0;
                int retval = Create_Sprite(Sprite_Spawner[i]->x, Sprite_Spawner[i]->y, Sprite_Spawner[i]->images);
                Sprite_Spawner[i]->hookfunc(retval);
            }
        }
    }
}
